<?php

namespace Modules\Auth\Repositories\V1;

use App\Entities\Eloquent\SfUsers;
use App\Repository\EloquentRepository;
use Illuminate\Database\Eloquent\Model;
use Modules\Auth\Entities\Eloquent\Usuario;


class UsuariosRepository extends EloquentRepository
{
    public function __construct()
    {
        parent::__construct(new Usuario());
    }

    public function getUserData($id)
    {
        return SfUsers::query()->select('users.id,users.email')
            ->leftJoin("sf_guard_user",function($query){
                $query->on("sf_guard_user.email","users.email");
            })
            ->where("users.id",$id)
            ->first();
            ;

    }

    public function getUserById($id)
    {
        return Usuario::query()->find(['id'=> $id]);
    }

    public function getUserBySalt($salt)
    {
        return SfUsers::query()->where('salt','=',$salt)
            ->first();
    }

}
