<?php

use Illuminate\Http\Request;
use Modules\Auth\Http\Controllers\AuthController;


/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::prefix('v1')->group(function() {
    Route::prefix('auth')->group(function() {

        Route::post('/login', [AuthController::class,'authenticate']);
        Route::post('/auto-login', [AuthController::class,'autoAuthenticate']);
        Route::get('/verify-token/{token}', [AuthController::class,'verifyUserToken']);
        Route::get('/get-token/{salt}', [AuthController::class,'getTokenBySalt']);

        Route::middleware('auth:sanctum')->group(function(){
            Route::get('/user', [AuthController::class,'user']);
            Route::post('/logout', [AuthController::class,'logout']);
            Route::get('/get-token', [AuthController::class,'getToken']);
        });

//        Route::get('/get-token', [AuthController::class,'getToken']);
    });

});

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return response()->success(auth()->user());
});
