<?php

namespace Modules\Auth\Service\V1;

use App\Service\BaseService;
use Modules\Auth\Repositories\V1\PersonalAccessTokensRepository;
use Modules\Auth\Repositories\V1\UsuariosRepository;

class UsuariosService extends BaseService
{
    private $usuariosRepository;
    private $personalAccssToken;

    public function __construct(UsuariosRepository $usuariosRepository,PersonalAccessTokensRepository $accessTokensRepository)
    {
        parent::__construct();
        $this->usuariosRepository = $usuariosRepository;
        $this->personalAccssToken = $accessTokensRepository;
    }

    public function getUserData($id){
        return $this->usuariosRepository->getUserData($id);
    }

    public function getUserByToken($token)
    {
        return $this->personalAccssToken->getUserByToken($token);

    }

    public function getUserById($id)
    {
        return $this->usuariosRepository->getUserById($id);
    }

    public function getUserBySalt($salt)
    {
        return $this->usuariosRepository->getUserBySalt($salt);
    }

}
