<?php

namespace Modules\Ft\Http\Controllers;

use App\Helpers\SettingHelper;
use App\Http\Resources\PofResource;
use App\Models\Cargo;
use App\Models\CargosMeta4;
use App\Models\Establecimiento;
use App\Models\Ft;
use App\Models\Pof;
use App\Models\PofTp;
use App\Rules\ReCaptchaRule;
use App\Service\Search\PofsSearchService;
use Illuminate\Validation\Rule;
use Maatwebsite\Excel\Excel as ExcelExcel;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Maatwebsite\Excel\Facades\Excel;
use Modules\Ft\Repositories\V1\FtReportesRepository;
use File;
use Response;
class PofController extends Controller
{


		public function index (PofsSearchService $search) {
				$query = $search->search();

				return   PofResource::collection($query);
		}
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function getPuestosEstablecimientos( $id )
    {

		    $data =  Pof::getPuestosoAltaTpTc($id);

		    $return = array();
		    foreach ($data as $key => $value) {
			//	    '( select count(*) from 088_POFTP  where c088_034_id = p.c034_id ) as tiene_apertura ',
				//		'( select  count(*) from 088_POFTP where c088_034_creacion_vacante_id = p.c034_id ) as cant_aperturas',
				    // Que el puesto NO exista en 088_POFTP.c088_034_id.
				    // que el puesto tenga registros en c088_034_creacion_vacante_id
				    // o sea.. que tenga aperturas o que no tenga aperturas. o sea los puesto sy aperturas.
				    if($value->tiene_apertura==0 && $value->cant_aperturas>0 )
						    continue;

				    $qry_apertura = "select * from   088_POFTP as ptp
								INNER JOIN 035_TURNOS t ON ptp.c088_035_id = t.c035_id
								LEFT JOIN 010_ASIGNATURAS a ON ptp.c088_010_id = a.c010_id 
								LEFT JOIN 007_PLANES pl ON ptp.c088_007_id = pl.c007_id 
				    where 
				       ptp.c088_034_id = ".$value->c034_id." and
				        ptp.c088_088_id is null   and  a.c010_id not in ( 1000, 6093 , 9847 )  ";

				    $aperturas =  \DB::select($qry_apertura);
				    $return[$value->c034_id] = (array)  $value;
				    foreach($aperturas as $ap) {
						    $return[$value->c034_id]['aperturas'][] = (array)  $ap;
				    }
		    }
		    $return_data =(array)  array_values($return);
		    return response()->json(array_values($return_data));
    }

		/**
		 * Store a newly created resource in storage.
		 * @param Request $request
		 * @return Renderable
		 */
		public function store(Request $request)
		{

				$datos = $request->toArray();
			// TODO: validar las horas segun sec del fut.
				//TODO: ver el priumer campod dela tabla Origen
				// las horas vienen difecnte.
				// TODO: validaciones

			$establecimiento = Establecimiento::where('c011_id',  $datos['establecimiento_id'])->firstOrFail();
			$cargo = Cargo::where('c030_id',  $datos['cargo'])->firstOrFail();

				$pof = new Pof();
				$pof->c034_011_id = $datos['establecimiento_id'];
				$pof->c034_caracter = "V";
				$pof->c034_030_id = $datos['cargo']; //verificar si lo esta guarfando
				$pof->c034_035_id1 = $datos['turno'];
				$pof->c034_horas = $datos['horas'];
				$pof->c034_077_id = $cargo->c030_077_id;
				$pof->c034_marca_web = 'W';
				$pof->save();
				//c034_239_id, c034_aniodesactivado, c034_680_id

				foreach ($datos['apertura'] as $aper){

						$tp = new PofTp();
						$tp->c088_034_id = $pof->c034_id;
						$tp->c088_010_id = $aper['asignatura_id'] ;
						$tp->c088_007_id = $aper['plan_id'];
						$tp->c088_ano = $aper['anio'];
						$tp->c088_div = $aper['division'];
						$tp->c088_035_id = $aper['turno_id'];
						$tp->c088_horas = is_array($aper['horas'])?$aper['horas']['id']:$aper['horas'];
						$tp->c088_observaciones = isset($aper['observaciones'])?$aper['observaciones']:'';
						$tp->c088_034_creacion_vacante_id = $aper['creacion_vacante_id']; //Permite asociar un puesto POF a la apertura para la funcionalidad de vacante creada, es una fk a la tabla 034 para indicar de dónde se obtienen las horas cátedra para esta sección de conformación de TP/TC
						$tp->c088_gef = $aper['gef'];
						$tp->c088_cuatrimestre = $aper['cuatrimestre'];; //TODO //indica el cuatrimestre de la asignatura, 1 o 2 (si esta en 0 o nulo es anual)
						$tp->save();
						//	c088_088_id 	fk a otro registro de la tabla 088; cuando este campo NO es NULL indica pérdida de vigencia de éste registro y su correspondiente TP/TC, por ser usado por el registro fk para conformar un nuevo TP/TC

				}

				return response([
						'message' => 'Success'
				], 200);

		}
		public function getPuestosPendientes(Request $request)
		{
				$rules = [
						'asignatura_id' => 'nullable|integer',
						'turno_id' => 'nullable|integer',
						'establecimiento_id' => 'required|integer',
						'anio' => 'nullable|integer',
						'division' => 'nullable|string',

				];

				$data = $request->validate($rules);
				$puestos = Pof::with(['plan','cargo','asignatura','curso','establecimiento','turno','caracter','aperturas'])
						->whereIn('c034_caracter', array("V", "Z"))
						->where('c034_marca_web', "W")
						->where('c034_011_id',$data['establecimiento_id']);

				// todo buscar por otros campos.
//				if(!empty($data['asignatura_id'])){
//						$puestos->where('',$data['asignatura_id']);
//				}
//				if(!empty($data['turno_id'])){
//						$puestos->where('',$data['turno_id']);
//				}
//				if(!empty($data['anio'])){
//						$puestos->where('',$data['anio']);
//				}
//				if(!empty($data['division'])){
//						$puestos->where('',$data['division']);
//				}

				;
		//		$puestos->get();

				return PofResource::collection($puestos->get() );

		}


		public function deletePuesto($id, $establecimiento_id)
		{
				$site = Pof::where('c034_id',$id )
						->where('c034_011_id', $establecimiento_id )
						->whereIn('c034_caracter', array("V", "Z"))->where('c034_marca_web',  "W" )
						->firstOrFail();
				$site->delete();


				return response()->json(['data' => 'success'], 200);

		}



}
