<?php

namespace Modules\Ft\Repositories\V1;

use App\Models\Asignatura;
use App\Models\Ft;
use App\Repository\EloquentRepository;
use Illuminate\Support\Facades\DB;


class FtReportesRepository extends EloquentRepository
{

    protected $response;
    protected $data;
    protected $limit;



    public function __construct($data)
    {
        parent::__construct(new Ft());
        $this->limit = " ";
        $this->data =$data;
    }

    public function outputCSV($sql, $cabecera){

        $results = DB::select( $sql );

        $results = json_decode(json_encode($results), true) ;
        # add headers for each column in the CSV download
        array_unshift($results , $cabecera );
        return $results;

    }
    public function datosDocenteActivos()
    {
        $where=array();
        $whereTitular=array();

        if($this->data['area_id']!=''){
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
            $whereTitular[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
        }

        $where[]="ft.c079_fecha_toma_de_posecion is not null ";
        $where[]="(ft.c079_fecha_baja is null or ft.c079_fecha_baja> curdate() )";
        $where[]=" ft.c079_caracter  in ( 'I','S') ";

        $whereTitular[]=" pof.c034_fcmzo  is not null ";
        $whereTitular[]=" pof.c034_caracter  in ( 'T','1','2') ";

        $where=implode(' and ', $where) . $this->limit;
        $whereTitular=implode(' and ', $whereTitular) . $this->limit;

        $consultaSuplente = "(select ".$this->getSelect(). " from `079_FORMUT` ft  ".$this->getInnerJoin() ." where ".$where ." )";
        $consultaTitular = "(select ".$this->getSelectTitular(). " from `034_POF` pof  ".$this->getInnerJoinTitular() ." where ".$whereTitular." )";;
        $consulta = "" . $consultaSuplente." union " .$consultaTitular . " order by area, nombre_establecimiento";

       return  $this->outputCSV($consulta, $this->getCabeceraReporte() );

    }

    public function datosDocenteTomaPosesion()
    {
        $where=array();

        $whereTitular=array();
        if($this->data['desde']!=''){
            $where[]="ft.c079_fecha_toma_de_posecion >= '" . $this->data['desde'] ."'";
            $whereTitular[]="pof.c034_fcmzo  >= '" . $this->data['desde'] ."'";
        }
        if($this->data['hasta']!=''){
            $where[]="ft.c079_fecha_toma_de_posecion <= '" . $this->data['hasta'] ."'";
            $whereTitular[]="pof.c034_fcmzo  <= '" . $this->data['hasta'] ."'";
        }

        if($this->data['area_id']!=''){
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
            $whereTitular[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
        }

        $where[]= "c079_fecha_toma_de_posecion is not null ";
        $where[]= "ft.c079_caracter  in ( 'I','S') ";
        $whereTitular[]="pof.c034_fcmzo  is not null ";
        $whereTitular[]="pof.c034_caracter  in ( 'T','1','2') ";
        $where=implode(' and ', $where) . $this->limit;

        $whereTitular=implode(' and ', $whereTitular) . $this->limit;

        $consultaSuplente = "(select ".$this->getSelect(). " from `079_FORMUT` ft  ".$this->getInnerJoin() ." where ".$where ." )";
        $consultaTitular = "(select ".$this->getSelectTitular(). " from `034_POF` pof  ".$this->getInnerJoinTitular() ." where ".$whereTitular." )";;
        $consulta = "" . $consultaSuplente." union " .$consultaTitular . " order by area, nombre_establecimiento";
        //echo $consulta;die();

       return  $this->outputCSV($consulta, $this->getCabeceraReporte() );

    }

    public function datosDocenteSinTomaPosesion()
    {
        $where=array();
        $whereTitular=array();
        if($this->data['desde']!=''){
            $where[]="ft.c079_fecha_carga >= '" . $this->data['desde'] ."'";
            $whereTitular[]="ft.c079_fecha_carga   >= '" . $this->data['desde'] ."'";
        }
        if($this->data['hasta']!=''){
            $where[]="ft.c079_fecha_carga <= '" . $this->data['hasta'] ."'";
            $whereTitular[]="ft.c079_fecha_carga   <= '" . $this->data['hasta'] ."'";
        }

        if($this->data['area_id']!=''){
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
            $whereTitular[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
        }

        $where[]="c079_fecha_toma_de_posecion is null ";
        $where[]=" ft.c079_020_id is not null  ";
        $where[]=" (cobertura.c005_des is not null or licencia.c004_des is not null) ";
        $where[]="ft.c079_caracter  in ( 'I','S') ";
        $whereTitular[]=" c034_020_id_des is not null ";
        $whereTitular[]=" c034_fcmzo is null ";
        $whereTitular[]="pof.c034_caracter  in ( 'T','1','2') ";
        $whereTitular[]=" (cobertura.c005_des is not null or licencia.c004_des is not null) ";

        $where=implode(' and ', $where) . $this->limit;
        $whereTitular=implode(' and ', $whereTitular) . $this->limit;

        $consultaSuplente = "(select ".$this->getSelect(). " from `079_FORMUT` ft  ".$this->getInnerJoin() ." where ".$where ." )";
        $consultaTitular = "(select ".$this->getSelectTitular(). " from `034_POF` pof  ".$this->getInnerJoinTitular() ." where ".$whereTitular." )";;
        $consulta = "" . $consultaSuplente." union " .$consultaTitular . " order by area, nombre_establecimiento";

        return $this->outputCSV($consulta, $this->getCabeceraReporte() );
    }

    public function datosDocenteNoTomaPosesion()
    {
        $where=array();
        if($this->data['desde']!='')
            $where[]="n.c281_fecha_no_tomo_posesion >= '" . $this->data['desde'] ."'";
        if($this->data['hasta']!='')
            $where[]="n.c281_fecha_no_tomo_posesion <= '" . $this->data['hasta'] ."'";
        if($this->data['area_id']!='')
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";

        $where[]="ft.c079_caracter  in ( 'I','S') ";
        $where=implode(' and ', $where) . $this->limit;

        $consulta = "SELECT
                         pof.c034_id  as id_pof,  pofp.c680_652_id  as id_gestion_pof, ft.c079_id_meta4  as id_meta4,
						area_escuela.c002_des as area, escuela.c011_nom as nombre_establecimiento, escuela.c011_esc as numero_establecimiento, escuela.c011_de as distrito_escolar, pof.c034_id as numero_puesto, cargo.c030_des as cargo, pof.c034_030_id as codigo_cargo, tipo_cargo.c031_des as tipo_cargo, persona.c020_ayn as nombre, persona.c020_documento, persona.c020_cuil, cobertura.c005_des as motivo_cobertura, licencia.c004_des as motivo_licencia, cese.c006_des as motivo_cese, ft.c079_fecha_toma_de_posecion as fecha_alta, ft.c079_fecha_baja as fecha_baja, ft.c079_id as numero_formulario, ft.c079_id as numero_propuesta, c156_des as caracter
						FROM 281_NO_TOMO_POSESION_DESIGNACION n
						INNER JOIN 079_FORMUT ft ON n.c281_079_id = ft.c079_id
						INNER join `034_POF` pof on ft.c079_034_id = pof.c034_id
						left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
						INNER join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
						INNER join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
						INNER join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
						INNER join `020_ARDAT` persona  on ft.c079_020_id  = persona.c020_id
						INNER JOIN 001_AREAANTIG a3 ON cargo.c030_001_id = a3.c001_id
						left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
						left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
						left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
						left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
						left join 156_CARACTER caracter on caracter.c156_id = ft.c079_caracter  where ".$where;
        //	echo $consulta;die();
       return  $this->outputCSV($consulta, $this->getCabeceraReporte() );
    }

    public function datosBajaConMotivos()
    {
        $where=array();

        $whereTitular=array();
        if($this->data['desde']!=''){
            $where[]="ft.c079_fecha_baja >= '" . $this->data['desde'] ."'";
            $whereTitular[]="ft.c079_fecha_baja  >= '" . $this->data['desde'] ."'";
        }
        if($this->data['hasta']!=''){
            $where[]="ft.c079_fecha_baja <= '" . $this->data['hasta'] ."'";
            $whereTitular[]="ft.c079_fecha_baja <= '" . $this->data['hasta'] ."'";
        }
        if($this->data['area_id']!=''){
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
            $whereTitular[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
        }

        $where[]="cese.c006_id is not null ";
        $whereTitular[]="cese.c006_id is not null ";
        $whereTitular[]="pof.c034_caracter  in ( 'T','1','2') ";
        $where[]="ft.c079_caracter  in ( 'I','S') ";

        $where=implode(' and ', $where) . $this->limit;
        $whereTitular=implode(' and ', $whereTitular) . $this->limit;
        $consultaSuplente = "(select ".$this->getSelect(). " from `079_FORMUT` ft  ".$this->getInnerJoin() ." where ".$where ." )";
        $consultaTitular = "(select ".$this->getSelectTitular(). " from `034_POF` pof  ".$this->getInnerJoinTitular() ." where ".$whereTitular." )";;
        $consulta = "" . $consultaSuplente." union " .$consultaTitular . " order by area, nombre_establecimiento";
        //echo $consulta;die();
        return $this->outputCSV($consulta,$this->getCabeceraReporte());
    }

    public function datosCantidadFTPorArea()
    {
        $where=array();
        if($this->data['desde']!='')
            $where[]="ft.c079_fecha_toma_de_posecion >= '" . $this->data['desde'] ."'";
        if($this->data['hasta']!='')
            $where[]="ft.c079_fecha_toma_de_posecion <= '" . $this->data['hasta'] ."'";
        if($this->data['area_id']!='')
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";

        $where[]="ft.c079_caracter  in ( 'I','S') ";
        $where=implode(' and ', $where) . $this->limit;

        $consulta = "select ".$this->getSelect(). " from `079_FORMUT` ft  ".$this->getInnerJoin() ." where ".$where;

        return $this->outputCSV($consulta,$this->getCabeceraReporte());
    }

    public function datosCambioSituacionRevista()
    {
        $where=array();
        if($this->data['desde']!='')
            $where[]="ft.c079_fecha_toma_de_posecion >= '" . $this->data['desde'] ."'";
        if($this->data['hasta']!='')
            $where[]="ft.c079_fecha_toma_de_posecion <= '" . $this->data['hasta'] ."'";
        if($this->data['area_id']!='')
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";

        $where[]=" c079_006_id in  ( 202, 98) ";
        $where[]="ft.c079_caracter  in ( 'I','S') ";
        $where=implode(' and ', $where) . $this->limit;
        $consulta = "select ".$this->getSelect(). " from 422_CAMBIO_DE_SITUACION_DE_REVISTA as cambio_revista
        inner join 079_FORMUT ft on ft.c079_020_id = cambio_revista.c422_020_id
        left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
        inner join `034_POF` pof on ft.c079_034_id = pof.c034_id
        left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
        inner join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
        inner join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
        inner join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
        left join `020_ARDAT` persona  on ft.c079_020_id  = persona.c020_id
        left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
        left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
        left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
        left join 156_CARACTER caracter on caracter.c156_id = ft.c079_caracter
        where ".$where;
       return  $this->outputCSV($consulta,$this->getCabeceraReporte());
    }

    public function datosCambioReemplazo()
    {
        $where=array();
        if($this->data['desde']!='')
            $where[]="ft.c079_fecha_toma_de_posecion >= '" . $this->data['desde'] ."'";
        if($this->data['hasta']!='')
            $where[]="ft.c079_fecha_toma_de_posecion <= '" . $this->data['hasta'] ."'";
        if($this->data['area_id']!='')
            $where[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";
        $where[]="ft.c079_caracter  in ( 'I','S') ";
        $where[]="
			persona.c020_id in (
			 SELECT c256_020_id from `256_LICENCIA_TITULAR` licencia_titular
			 where licencia_titular.c256_020_id =  persona.c020_id
			 and licencia_titular.c256_fecha_desde = ft.c079_fecha_toma_de_posecion
			)
			or
			ft.c079_id in (
			 SELECT c079_020_id from `260_LICENCIA_FORMULARIOT`  licencia_sup
			 inner join `079_FORMUT` ft_lic on ft_lic.c079_id = licencia_sup.c260_079_id
			 where  ft.c079_020_id =ft_lic.c079_020_id
			 and licencia_sup.c260_fecha_desde  = ft.c079_fecha_toma_de_posecion
			)
			or
			persona.c020_id in (
			 SELECT c240_020_id from `240_BAJA_TITULARES_WSAD`  baja_titulares
			 where baja_titulares.c240_020_id =  persona.c020_id
			 and baja_titulares.c240_fecha_baja = ft.c079_fecha_toma_de_posecion
			)";
        $where=implode(' and ', $where) . $this->limit;
        $consulta = "select ".$this->getSelect(). " from `079_FORMUT` ft  ".$this->getInnerJoin() . "   where ".$where;
      return   $this->outputCSV($consulta,$this->getCabeceraReporte());
    }

    public function datosDocentesCesaronLicenciaron()
    {
        $conditions=array();
        $where= '';
        if($this->data['desde']!='')
            $conditions[]="ft.c079_fecha_baja >= '" . $this->data['desde'] ."'";
        if($this->data['hasta']!='')
            $conditions[]="ft.c079_fecha_baja <= '" . $this->data['hasta'] ."'";
        if($this->data['area_id']!='')
            $conditions[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";

        $conditions[]="ft.c079_caracter  in ( 'I','S') ";

        if(count($conditions)>0){
            $where= ' and '. implode(' and ', $conditions) .' ';
        }


        $consulta = "select    pof.c034_id  as id_pof,  pofp.c680_652_id  as id_gestion_pof, ft.c079_id_meta4  as id_meta4, area_escuela.c002_des as area, escuela.c011_nom as nombre_establecimiento, escuela.c011_esc as numero_establecimiento, escuela.c011_de as distrito_escolar, pof.c034_id as numero_puesto, cargo.c030_des as cargo, pof.c034_030_id as codigo_cargo, tipo_cargo.c031_des as tipo_cargo, persona.c020_ayn as nombre, persona.c020_documento, persona.c020_cuil, cobertura.c005_des as motivo_cobertura, licencia.c004_des as motivo_licencia, cese.c006_des as motivo_cese, ft.c079_fecha_toma_de_posecion as fecha_alta, ft.c079_fecha_baja as fecha_baja, ft.c079_id as numero_formulario, ft.c079_id as numero_propuesta, c156_des as caracter
					from `079_FORMUT` ft  left join `034_POF` pof on ft.c079_034_id = pof.c034_id
					left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
					left join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
					left join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
					left join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
					left join `020_ARDAT` persona  on ft.c079_020_id  = persona.c020_id
					left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
					left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
					left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
					left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
					left join 156_CARACTER caracter on caracter.c156_id = ft.c079_caracter
					where
						ft.c079_020_id in (
						select  pof_tit.c034_020_id_des  from `034_POF` pof_tit
						where
						pof_tit.c034_020_id_des = ft.c079_020_id
						and  YEAR(ft.c079_fecha_baja) = YEAR(pof_tit.c034_fcmzo)
						AND MONTH(ft.c079_fecha_baja) = MONTH(pof_tit.c034_fcmzo)
						and c034_caracter in ('T', '1', '2')
					)
			  ".$where . $this->limit;

     return    $this->outputCSV($consulta,$this->getCabeceraReporte());
    }

    public function datosPedidosSinDocente()
    {
        $conditions=array();
        $where= '';
        if($this->data['desde']!='')
            $conditions[]="ft.c079_fecha_carga >= '" . $this->data['desde'] ."'";
        if($this->data['hasta']!='')
            $conditions[]="ft.c079_fecha_carga <= '" . $this->data['hasta'] ."'";
        if($this->data['area_id']!='')
            $conditions[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";

        if(count($conditions)>0){
            $where= ' and '. implode(' and ', $conditions) .' ';
        }

        $consulta = "select
                    pof.c034_id  as id_pof,  pofp.c680_652_id  as id_gestion_pof, ft.c079_id_meta4  as id_meta4, area_escuela.c002_des as area, modalidad.c012_des as modalidad, escuela.c011_nom as nombre_establecimiento, escuela.c011_esc as numero_establecimiento, escuela.c011_de as distrito_escolar, pof.c034_id as numero_puesto, cargo.c030_des as cargo, pof.c034_030_id as codigo_cargo, tipo_cargo.c031_des as tipo_cargo, cobertura.c005_des as motivo_cobertura, licencia.c004_des as motivo_licencia, cese.c006_des as motivo_cese, ft.c079_fecha_toma_de_posecion as fecha_alta, ft.c079_fecha_baja as fecha_baja, ft.c079_id as numero_formulario,  c156_des as caracter
					, horario.h as horarios,case  WHEN ( asig.c010_des IN (6125 , 6169, 3935, 3938, 5542))  THEN asig.c010_des
                    else  a.c010_des  end as asignatura, turno.c035_des, pof.c034_ano,
                    pof.c034_div, pof.c034_horas ,eppa.c755_especialidad, plan.c007_des , c079_fecha_carga

					from `079_FORMUT` ft  left join `034_POF` pof on ft.c079_034_id = pof.c034_id
					   left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
					left join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
					left join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
					left join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
					left join `020_ARDAT` persona  on ft.c079_020_id  = persona.c020_id
					left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
					left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
					left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
					left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
					left join 156_CARACTER caracter on caracter.c156_id = ft.c079_caracter
					left join `010_ASIGNATURAS` a on pof.c034_010_id = a.c010_id
					left join `010_ASIGNATURAS` asig on ft.c079_010_id = asig.c010_id
					left join `755_ESPECIALIDAD_PROFESOR_POR_ASIGNATURA` eppa on eppa.c755_id = ft.c079_755_id
					left join `007_PLANES` plan  on plan.c007_id = pof.c034_007_id
					left join `035_TURNOS` turno  on turno.c035_id = pof.c034_035_id1
					left JOIN 012_MODALIDAD modalidad ON escuela.c011_012_id = modalidad.c012_id
					left join
						(      SELECT c237_034_id, GROUP_CONCAT(horarios SEPARATOR ', ') AS h FROM (
                  SELECT CONCAT(
                        c236_desc,
                        ': ',
                        GROUP_CONCAT(
                        DATE_FORMAT(c237_horario_desde, \"%H:%i\"),
                          ' - ',
                          DATE_FORMAT(c237_horario_hasta, \"%H:%i\")
                          SEPARATOR ' '
                        )
                      ) AS horarios,  c237_034_id
                    FROM 237_GRILLA_HORARIA g
                    INNER JOIN 236_DIA_DE_LA_SEMANA d ON c237_236_id = c236_id

                    GROUP BY c237_034_id, c237_236_id
                ) as horario
                group by c237_034_id )
                	as horario on horario.c237_034_id= ft.c079_034_id

					where
					c079_020_id is null and (c034_010_id in (".implode(',', Asignatura::$asignatura_hora_libre_cero).") or  c079_010_id in (".implode(',', Asignatura::$asignatura_hora_libre_cero)."))
			  ".$where . ' order by c079_fecha_carga desc ' . $this->limit;
        $cabecera =  array(
            'Id Pof', 'Id Gestion POF',  'Id Meta4',
            'Area',
            'Modalidad',
            'Nombre establecimiento' ,
            'Numero establecimiento',
            'Distrito escolar',
            'Numero de puesto',
            'Nombre del cargo',
            'Codigo del cargo',
            'Tipo del cargo',
            'Motivo de la cobertura',
            'Motivo de la licencia',
            'Motivo de cese',
            'Fecha de alta',
            'Fecha de baja',
            'Numero de formulario',
            'Caracter','Horarios', 'Asignatura','Turno','Año','Division','Horas','EspecialidadCoreap','EspecielidadPof', 'FechaCarga');

       return  $this->outputCSV($consulta,$cabecera);
    }

    public function datosInvocacionServicios( $tipo = 0)
    {
        $conditions=array();
        $where= '';
        if($tipo != 1) {
            if ($this->data['desde'] != '')
                $conditions[] = "ft.c079_fecha_toma_de_posecion >= '" . $this->data['desde'] . "'";
            if ($this->data['hasta'] != '')
                $conditions[] = "ft.c079_fecha_toma_de_posecion <= '" . $this->data['hasta']. "'";
        }else{
            if ($this->data['desde'] != '')
                $conditions[] = "ft.c079_fecha_baja >= '" . $this->data['desde'] . "'";
            if ($this->data['hasta'] != '')
                $conditions[] = "ft.c079_fecha_baja <= '" . $this->data['hasta'] . "'";
        }
        if($this->data['area_id']!='')
            $conditions[]=" area_escuela.c002_id = '" . $this->data['area_id'] ."'";

        $conditions[]=" area_escuela.c002_id in  ('I','P','C','A','E','TT','M')";

        $conditions[]="ft.c079_caracter  in ( 'I','S') ";

        if($tipo == 0){
            $conditions[]=" c746_evento  in  ('ALTA','ALTAEMPLEADO')";
        }elseif ($tipo== 1){
            $conditions[]=" c746_evento  in  ('BAJA','BAJAEMPLEADO')";
        }elseif ($tipo ==2){
            $conditions[]=" c746_evento  not in  ('BAJA','BAJAEMPLEADO', 'ALTA','ALTAEMPLEADO')";
        }
        if(count($conditions)>0){
            $where= ' where '. implode(' and ', $conditions) .' ';
        }


        $consulta = "select
        pof.c034_id  as id_pof,  pofp.c680_652_id  as id_gestion_pof, ft.c079_id_meta4  as id_meta4,
			area_escuela.c002_des as area, escuela.c011_nom as nombre_establecimiento, escuela.c011_esc as numero_establecimiento, escuela.c011_de as distrito_escolar,
			pof.c034_id as numero_puesto, cargo.c030_des as cargo, pof.c034_030_id as codigo_cargo, tipo_cargo.c031_des as tipo_cargo, persona.c020_ayn as nombre, persona.c020_documento,
			persona.c020_cuil, cobertura.c005_des as motivo_cobertura, licencia.c004_des as motivo_licencia, cese.c006_des as motivo_cese, ft.c079_fecha_toma_de_posecion
			as fecha_alta, ft.c079_fecha_baja as fecha_baja, ft.c079_id as numero_formulario, ft.c079_id as numero_propuesta, c156_des as caracter ,
			 c746_evento as evento,
			c746_fecha_envio as fecha_envio,
			c746_datos_enviados as datos_enviados,
			c746_codigo_retorno as codigo_retorno,
			c746_mensaje_retorno as mensaje_retorno,

             estado.c264_estado as estado
			from `079_FORMUT` ft
			inner  join `746_REGISTRO_LOG_FORMUT_SIAL` log_ft on log_ft.c746_079_id = ft.c079_id
			LEFT join `sf_guard_user` log_usuario on log_usuario.id = log_ft.c746_usuario_id
			left join `034_POF` pof on ft.c079_034_id = pof.c034_id
			left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
			left join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
			left join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
			left join 156_CARACTER caracter on caracter.c156_id = ft.c079_caracter
			left join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
			left join `020_ARDAT` persona  on ft.c079_020_id  = persona.c020_id
			left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
			left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
			left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
			left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
			left join `264_FORMULARIOT_ESTADO` estado on ft.c079_264_id  = estado.c264_id

			  ".$where . $this->limit;
        $cabecera= array('Id Pof', 'Id Gestion POF',  'Id Meta4','Evento','Fecha envio','Datos enviados','Codigo Retorno', 'Mensaje Retorno','Estado');
        //echo $consulta; die();
        return  $this->outputCSV($consulta, array_merge($this->getCabeceraReporte(),$cabecera));
    }



    private function getCabeceraReporte(){
        return array_keys($this->getFields());
    }

    private function getSelect(){
        return implode(', ',array_values($this->getFields()));
    }

    private function getSelectTitular(){
        return implode(', ',array_values($this->getFieldsTitular()));
    }

    private function getInnerJoin(){
        return  "left join `034_POF` pof on ft.c079_034_id = pof.c034_id
					left join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
					left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
					left join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
					left join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
					left join `020_ARDAT` persona  on ft.c079_020_id  = persona.c020_id
					left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
					left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
					left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
					left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
					left join 156_CARACTER caracter on caracter.c156_id = ft.c079_caracter
					";
    }

    private function getFields(){
        return array(
            'Id Pof'=>'pof.c034_id  as id_pof',
            'Id Gestion POF'=>'pofp.c680_652_id  as id_gestion_pof',
             'Id Meta4'=>'ft.c079_id_meta4  as id_meta4',
            'Area'=>'area_escuela.c002_des as area',
            'Nombre establecimiento' =>'escuela.c011_nom as nombre_establecimiento',
            'Numero establecimiento'=>'escuela.c011_esc as numero_establecimiento',
            'Distrito escolar'=>'escuela.c011_de as distrito_escolar',
            'Numero de puesto'=>'pof.c034_id as numero_puesto',
            'Nombre del cargo'=>'cargo.c030_des as cargo',

            'Codigo del cargo'=>'pof.c034_030_id as codigo_cargo',
            'Tipo del cargo'=>'tipo_cargo.c031_des as tipo_cargo',
            'Nombre y apellido'=>'persona.c020_ayn as nombre',
            'DNI'=>'persona.c020_documento',
            'CUIL'=>'persona.c020_cuil',
            'Motivo de la cobertura'=>'cobertura.c005_des as motivo_cobertura',
            'Motivo de la licencia'=>'licencia.c004_des as motivo_licencia',
            'Motivo de cese'=>'cese.c006_des as motivo_cese',
            'Fecha de alta'=>'ft.c079_fecha_toma_de_posecion as fecha_alta',
            'Fecha de baja'=>'ft.c079_fecha_baja as fecha_baja',
            'Numero de formulario'=>'ft.c079_id as numero_formulario',
            'Numero de la propuesta'=>'ft.c079_id as numero_propuesta',
            'Caracter'=> 'c156_des as caracter'
        );
    }

    private function getInnerJoinTitular(){
        return  "left join `079_FORMUT` ft on ft.c079_034_id = pof.c034_id and ft.c079_020_id = pof.c034_020_id_des
        	left join `680_POF_P` pofp on pofp.c680_id = pof.c034_680_id
					left join `011_NOMENCLADOR` escuela on pof.c034_011_id = escuela.c011_id
					left join `002_AREANOMEN` area_escuela on area_escuela.c002_id = escuela.c011_002_id
					left join `030_CARGOS` cargo on  pof.c034_030_id = cargo.c030_id
					left join `020_ARDAT` persona  on pof.c034_020_id_des  = persona.c020_id
					left join `031_TIPOCARGO` tipo_cargo on  tipo_cargo.c031_id = cargo.c030_031_id
					left join `006_ORICESE` cese on ft.c079_006_id  = cese.c006_id
					left join `005_ORIVACANTE` cobertura on cobertura.c005_id = c079_005_id
					left join `004_ORILICENCIA` licencia on licencia.c004_id = c079_004_id
					left join 156_CARACTER caracter on caracter.c156_id = pof.c034_caracter ";
    }
    private function getFieldsTitular(){
        return array(
            'Id Pof'=>'pof.c034_id  as id_pof',
            'Id Gestion POF'=>'pofp.c680_652_id  as id_gestion_pof',
            'Id Meta4'=>'ft.c079_id_meta4  as id_meta4',
            'Area'=>'area_escuela.c002_des as area',
            'Nombre establecimiento' =>'escuela.c011_nom as nombre_establecimiento',
            'Numero establecimiento'=>'escuela.c011_esc as numero_establecimiento',
            'Distrito escolar'=>'escuela.c011_de as distrito_escolar',
            'Numero de puesto'=>'pof.c034_id as numero_puesto',
            'Nombre del cargo'=>'cargo.c030_des as cargo',
            'Codigo del cargo'=>'pof.c034_030_id as codigo_cargo',
            'Tipo del cargo'=>'tipo_cargo.c031_des as tipo_cargo',
            'Nombre y apellido'=>'persona.c020_ayn as nombre',
            'DNI'=>'persona.c020_documento',
            'CUIL'=>'persona.c020_cuil',
            'Motivo de la cobertura'=>'cobertura.c005_des as motivo_cobertura',
            'Motivo de la licencia'=>'licencia.c004_des as motivo_licencia',
            'Motivo de cese'=>'cese.c006_des as motivo_cese',
            'Fecha de alta'=>'pof.c034_fcmzo as fecha_alta',
            'Fecha de baja'=>'ft.c079_fecha_baja as fecha_baja',
            'Numero de formulario'=>'ft.c079_id as numero_formulario',
            'Numero de la propuesta'=>'ft.c079_id as numero_propuesta',
            'Caracter'=> 'c156_des as caracter'
        );
    }




}
