<?php

namespace Modules\OrdenProviciones\Dto;

use App\Dto\BaseDto;
use Carbon\Carbon;

class ListadoLacteoDto extends BaseDto
{
    protected $id;

    protected $beca_id;
    protected $establecimiento_id;
    protected $establecimiento;

    protected $nivel_id;
    protected $codigo;
    protected $empresa;

    protected $info;
    protected $distrito;

    protected $dias;

    protected $vigente;
    protected $observacion;
    protected $fecha_inicio;
    protected $fecha_modificacion;
    protected $litros_diarios;
    protected $leche_semanal;
    protected $litros_leche_semanal_descremada;
    protected $yogur_semanal;
    protected $yogur_diario;
    protected $listro_yogur_semanal_descremanda;
    protected $litros_semanales_sin_lactosa;
    protected $bb1_unidades_semanales;
    protected $bb2_unidades_semanales;
    protected $domicilio_entrega;

    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);
        $this->litros_diarios = (isset($attributes['servicios'][19]['cantidad']))?$attributes['servicios'][19]['cantidad']:null;
        $this->leche_semanal = (isset($attributes['servicios'][20]['cantidad']))?$attributes['servicios'][20]['cantidad']:null;
        $this->litros_leche_semanal_descremada = (isset($attributes['servicios'][11]['cantidad']))?$attributes['servicios'][11]['cantidad']:null;
        $this->yogur_semanal = (isset($attributes['servicios'][13]['cantidad']))?$attributes['servicios'][13]['cantidad']:null;
        $this->yogur_diario = (isset($attributes['servicios'][12]['cantidad']))?$attributes['servicios'][12]['cantidad']:null;
        $this->listro_yogur_semanal_descremanda = (isset($attributes['servicios'][14]['cantidad']))?$attributes['servicios'][14]['cantidad']:null;
        $this->litros_semanales_sin_lactosa = (isset($attributes['servicios'][16]['cantidad']))?$attributes['servicios'][16]['cantidad']:null;
        $this->bb1_unidades_semanales = (isset($attributes['servicios'][17]['cantidad']))?$attributes['servicios'][17]['cantidad']:null;
        $this->bb2_unidades_semanales = (isset($attributes['servicios'][18]['cantidad']))?$attributes['servicios'][18]['cantidad']:null;

        if (!is_null($attributes['fecha_inicio']))
        {
            $date = new Carbon($attributes['fecha_inicio']);
            $this->fecha_inicio = $date->format('d/m/Y');
        }


        if (!is_null($attributes['fecha_modificacion'])){

            $date_m = new Carbon($attributes['fecha_modificacion']);
            $this->fecha_modificacion = $date_m->format('d/m/Y');
        }



    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param mixed $id
     */
    public function setId($id): void
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getBecaId()
    {
        return $this->beca_id;
    }

    /**
     * @param mixed $beca_id
     */
    public function setBecaId($beca_id): void
    {
        $this->beca_id = $beca_id;
    }

    /**
     * @return mixed
     */
    public function getEstablecimientoId()
    {
        return $this->establecimiento_id;
    }

    /**
     * @param mixed $establecimiento_id
     */
    public function setEstablecimientoId($establecimiento_id): void
    {
        $this->establecimiento_id = $establecimiento_id;
    }

    /**
     * @return mixed
     */
    public function getEstablecimiento()
    {
        return $this->establecimiento;
    }

    /**
     * @param mixed $establecimiento
     */
    public function setEstablecimiento($establecimiento): void
    {
        $this->establecimiento = $establecimiento;
    }

    /**
     * @return mixed
     */
    public function getNivelId()
    {
        return $this->nivel_id;
    }

    /**
     * @param mixed $nivel_id
     */
    public function setNivelId($nivel_id): void
    {
        $this->nivel_id = $nivel_id;
    }

    /**
     * @return mixed
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * @param mixed $codigo
     */
    public function setCodigo($codigo): void
    {
        $this->codigo = $codigo;
    }

    /**
     * @return mixed
     */
    public function getEmpresa()
    {
        return $this->empresa;
    }

    /**
     * @param mixed $empresa
     */
    public function setEmpresa($empresa): void
    {
        $this->empresa = $empresa;
    }

    /**
     * @return mixed
     */
    public function getInfo()
    {
        return $this->info;
    }

    /**
     * @param mixed $info
     */
    public function setInfo($info): void
    {
        $this->info = $info;
    }

    /**
     * @return mixed
     */
    public function getDistrito()
    {
        return $this->distrito;
    }

    /**
     * @param mixed $distrito
     */
    public function setDistrito($distrito): void
    {
        $this->distrito = $distrito;
    }

    /**
     * @return mixed
     */
    public function getDias()
    {
        return $this->dias;
    }

    /**
     * @param mixed $dias
     */
    public function setDias($dias): void
    {
        $this->dias = $dias;
    }

    /**
     * @return mixed
     */
    public function getVigente()
    {
        return $this->vigente;
    }

    /**
     * @param mixed $vigente
     */
    public function setVigente($vigente): void
    {
        $this->vigente = $vigente;
    }

    /**
     * @return mixed
     */
    public function getObservacion()
    {
        return $this->observacion;
    }

    /**
     * @param mixed $observacion
     */
    public function setObservacion($observacion): void
    {
        $this->observacion = $observacion;
    }

    public function getFechaInicio(): string
    {
        return $this->fecha_inicio;
    }

    public function setFechaInicio(string $fecha_inicio): void
    {
        $this->fecha_inicio = $fecha_inicio;
    }

    public function getFechaModificacion(): string
    {
        return $this->fecha_modificacion;
    }

    public function setFechaModificacion(string $fecha_modificacion): void
    {
        $this->fecha_modificacion = $fecha_modificacion;
    }

    public function getLitrosDiarios(): mixed
    {
        return $this->litros_diarios;
    }

    public function setLitrosDiarios(mixed $litros_diarios): void
    {
        $this->litros_diarios = $litros_diarios;
    }

    public function getLecheSemanal(): mixed
    {
        return $this->leche_semanal;
    }

    public function setLecheSemanal(mixed $leche_semanal): void
    {
        $this->leche_semanal = $leche_semanal;
    }

    public function getLitrosLecheSemanalDescremada(): mixed
    {
        return $this->litros_leche_semanal_descremada;
    }

    public function setLitrosLecheSemanalDescremada(mixed $litros_leche_semanal_descremada): void
    {
        $this->litros_leche_semanal_descremada = $litros_leche_semanal_descremada;
    }

    public function getYogurSemanal(): mixed
    {
        return $this->yogur_semanal;
    }

    public function setYogurSemanal(mixed $yogur_semanal): void
    {
        $this->yogur_semanal = $yogur_semanal;
    }

    public function getYogurDiario(): mixed
    {
        return $this->yogur_diario;
    }

    public function setYogurDiario(mixed $yogur_diario): void
    {
        $this->yogur_diario = $yogur_diario;
    }

    public function getListroYogurSemanalDescremanda(): mixed
    {
        return $this->listro_yogur_semanal_descremanda;
    }

    public function setListroYogurSemanalDescremanda(mixed $listro_yogur_semanal_descremanda): void
    {
        $this->listro_yogur_semanal_descremanda = $listro_yogur_semanal_descremanda;
    }

    public function getLitrosSemanalesSinLactosa(): mixed
    {
        return $this->litros_semanales_sin_lactosa;
    }

    public function setLitrosSemanalesSinLactosa(mixed $litros_semanales_sin_lactosa): void
    {
        $this->litros_semanales_sin_lactosa = $litros_semanales_sin_lactosa;
    }

    public function getBb1UnidadesSemanales(): mixed
    {
        return $this->bb1_unidades_semanales;
    }

    public function setBb1UnidadesSemanales(mixed $bb1_unidades_semanales): void
    {
        $this->bb1_unidades_semanales = $bb1_unidades_semanales;
    }

    public function getBb2UnidadesSemanales(): mixed
    {
        return $this->bb2_unidades_semanales;
    }

    public function setBb2UnidadesSemanales(mixed $bb2_unidades_semanales): void
    {
        $this->bb2_unidades_semanales = $bb2_unidades_semanales;
    }

    /**
     * @return mixed
     */
    public function getDomicilioEntrega()
    {
        return $this->domicilio_entrega;
    }

    /**
     * @param mixed $domicilio_entrega
     */
    public function setDomicilioEntrega($domicilio_entrega): void
    {
        $this->domicilio_entrega = $domicilio_entrega;
    }


}
