<?php

namespace Modules\OrdenProviciones\Dto;

use App\Dto\BaseDto;
use Carbon\Carbon;

class ListadoSolidoDto extends BaseDto
{
    protected $id;

    protected $beca_id;
    protected $establecimiento_id;
    protected $establecimiento;

    protected $nivel_id;
    protected $codigo;
    protected $empresa;
    protected $comedor_cien;
    protected $comedor_cincuenta;
    protected $comedor_docente;
    protected $vianda_cien;
    protected $vianda_cincuenta;
    protected $vianda_docente;
    protected $desayuno_segundo;
    protected $desayuno;
    protected $merienda;
    protected $refrigerio;
    protected $info;
    protected $distrito;

    protected $dias;

    protected $vigente;

    protected $observacion;

    protected $fecha_inicio;
    protected $fecha_modificacion;

    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);
        $this->comedor_cien = $attributes['servicios'][4]['cantidad'];
        $this->comedor_cincuenta = $attributes['servicios'][5]['cantidad'];
        $this->vianda_cien = $attributes['servicios'][7]['cantidad'];
        $this->vianda_cincuenta = $attributes['servicios'][8]['cantidad'];
        $this->refrigerio = $attributes['servicios'][1]['cantidad'];
        $this->desayuno_segundo = $attributes['servicios'][10]['cantidad'];
        $this->merienda = $attributes['servicios'][3]['cantidad'];
        $this->comedor_docente = $attributes['servicios'][6]['cantidad'];
        $this->vianda_docente = $attributes['servicios'][9]['cantidad'];
        $this->desayuno = $attributes['servicios'][2]['cantidad'];

        $date = new Carbon($attributes['fecha_inicio']);
        $this->fecha_inicio = $date->format('d/m/Y');

        if (!is_null($attributes['fecha_modificacion'])){

            $date_m = new Carbon($attributes['fecha_modificacion']);
            $this->fecha_modificacion = $date_m->format('d/m/Y');
        }



    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param mixed $id
     */
    public function setId($id): void
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * @param mixed $codigo
     */
    public function setCodigo($codigo): void
    {
        $this->codigo = $codigo;
    }

    /**
     * @return mixed
     */
    public function getEmpresa()
    {
        return $this->empresa;
    }

    /**
     * @param mixed $empresa
     */
    public function setEmpresa($empresa): void
    {
        $this->empresa = $empresa;
    }

    /**
     * @return mixed
     */
    public function getComedorCien()
    {
        return $this->comedor_cien;
    }

    /**
     * @param mixed $comedor_cien
     */
    public function setComedorCien($comedor_cien): void
    {
        $this->comedor_cien = $comedor_cien;
    }

    /**
     * @return mixed
     */
    public function getComedorCincuenta()
    {
        return $this->comedor_cincuenta;
    }

    /**
     * @param mixed $comedor_cincuenta
     */
    public function setComedorCincuenta($comedor_cincuenta): void
    {
        $this->comedor_cincuenta = $comedor_cincuenta;
    }

    /**
     * @return mixed
     */
    public function getComedorDocente()
    {
        return $this->comedor_docente;
    }

    /**
     * @param mixed $comedor_docente
     */
    public function setComedorDocente($comedor_docente): void
    {
        $this->comedor_docente = $comedor_docente;
    }

    /**
     * @return mixed
     */
    public function getViandaCien()
    {
        return $this->vianda_cien;
    }

    /**
     * @param mixed $vianda_cien
     */
    public function setViandaCien($vianda_cien): void
    {
        $this->vianda_cien = $vianda_cien;
    }

    /**
     * @return mixed
     */
    public function getViandaCincuenta()
    {
        return $this->vianda_cincuenta;
    }

    /**
     * @param mixed $vianda_cincuenta
     */
    public function setViandaCincuenta($vianda_cincuenta): void
    {
        $this->vianda_cincuenta = $vianda_cincuenta;
    }

    /**
     * @return mixed
     */
    public function getViandaDocente()
    {
        return $this->vianda_docente;
    }

    /**
     * @param mixed $vianda_docente
     */
    public function setViandaDocente($vianda_docente): void
    {
        $this->vianda_docente = $vianda_docente;
    }

    /**
     * @return mixed
     */
    public function getDesayunoSegundo()
    {
        return $this->desayuno_segundo;
    }

    /**
     * @param mixed $desayuno_segundo
     */
    public function setDesayunoSegundo($desayuno_segundo): void
    {
        $this->desayuno_segundo = $desayuno_segundo;
    }

    /**
     * @return mixed
     */
    public function getDesayuno()
    {
        return $this->desayuno;
    }

    /**
     * @param mixed $desayuno
     */
    public function setDesayuno($desayuno): void
    {
        $this->desayuno = $desayuno;
    }

    /**
     * @return mixed
     */
    public function getMerienda()
    {
        return $this->merienda;
    }

    /**
     * @param mixed $merienda
     */
    public function setMerienda($merienda): void
    {
        $this->merienda = $merienda;
    }

    /**
     * @return mixed
     */
    public function getRefrigerio()
    {
        return $this->refrigerio;
    }

    /**
     * @param mixed $refrigerio
     */
    public function setRefrigerio($refrigerio): void
    {
        $this->refrigerio = $refrigerio;
    }

    /**
     * @return mixed
     */
    public function getInfo():array
    {
        return $this->info ;
    }

    /**
     * @param mixed $info
     */
    public function setInfo($info): void
    {
        $this->info = $info;
    }

    /**
     * @return mixed
     */
    public function getEstablecimientoId()
    {
        return $this->establecimiento_id;
    }

    /**
     * @param mixed $establecimiento_id
     */
    public function setEstablecimientoId($establecimiento_id): void
    {
        $this->establecimiento_id = $establecimiento_id;
    }

    /**
     * @return mixed
     */
    public function getDistrito()
    {
        return $this->distrito;
    }

    /**
     * @param mixed $distrito
     */
    public function setDistrito($distrito): void
    {
        $this->distrito = $distrito;
    }

    /**
     * @return mixed
     */
    public function getDias()
    {
        return $this->dias;
    }

    /**
     * @param mixed $dias
     */
    public function setDias($dias): void
    {
        $this->dias = $dias;
    }

    /**
     * @return mixed
     */
    public function getVigente()
    {
        return $this->vigente;
    }

    /**
     * @param mixed $vigente
     */
    public function setVigente($vigente): void
    {
        $this->vigente = $vigente;
    }

    /**
     * @return mixed
     */
    public function getNivelId()
    {
        return $this->nivel_id;
    }

    /**
     * @param mixed $nivel_id
     */
    public function setNivelId($nivel_id): void
    {
        $this->nivel_id = $nivel_id;
    }

    /**
     * @return mixed
     */
    public function getObservacion()
    {
        return $this->observacion;
    }

    /**
     * @param mixed $observacion
     */
    public function setObservacion($observacion): void
    {
        $this->observacion = $observacion;
    }

    /**
     * @return mixed
     */
    public function getFechaInicio()
    {
        return $this->fecha_inicio;
    }

    /**
     * @param mixed $fecha_inicio
     */
    public function setFechaInicio($fecha_inicio): void
    {
        $this->fecha_inicio = $fecha_inicio;
    }

    /**
     * @return mixed
     */
    public function getFechaModificacion()
    {
        return $this->fecha_modificacion;
    }

    /**
     * @param mixed $fecha_modificacion
     */
    public function setFechaModificacion($fecha_modificacion): void
    {
        $this->fecha_modificacion = $fecha_modificacion;
    }

    /**
     * @return mixed
     */
    public function getEstablecimiento()
    {
        return $this->establecimiento;
    }

    /**
     * @param mixed $establecimiento
     */
    public function setEstablecimiento($establecimiento): void
    {
        $this->establecimiento = $establecimiento;
    }

    /**
     * @return mixed
     */
    public function getBecaId()
    {
        return $this->beca_id;
    }

    /**
     * @param mixed $beca_id
     */
    public function setBecaId($beca_id): void
    {
        $this->beca_id = $beca_id;
    }



}
