<?php

namespace Modules\OrdenProviciones\Repositories\V1;

use App\Repository\EloquentRepository;
use Illuminate\Support\Facades\DB;
use Modules\OrdenProviciones\Entities\V1\EstablecimientosBecas;

class EstablecimientosBecasRepository extends EloquentRepository
{
    public function __construct()
    {
        parent::__construct(new EstablecimientosBecas());
    }

    public function getBecasPorEstablecimiento($establecimiento_id)
    {

        return DB::table('740_ESTABLECIMIENTOS_BECAS AS e')
            ->select(
                [
                    'e.c740_id AS id',
                    'e.c740_codigo AS codigo',
                    'e.c740_nombre AS nombre',
                    'e.c740_de AS distrito_escolar',
                    'e.c740_011_id AS establecimiento_id',
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 1 THEN 1 ELSE 0 END ) AS pendiente_validacion'),
                    DB::raw('SUM(CASE WHEN b.c367_363_id = 1 OR b.c367_363_id = 7 OR b.c367_363_id = 8 OR b.c367_363_id = 9 THEN 1 ELSE 0 END ) AS modulo_validacion'),
                    DB::raw('SUM(CASE WHEN b.c367_363_id = 2 OR b.c367_363_id = 3 OR b.c367_363_id = 4 OR b.c367_363_id = 5 OR b.c367_363_id = 6 OR b.c367_363_id = 10 OR b.c367_363_id = 11 OR b.c367_363_id = 12 THEN 1 ELSE 0 END ) AS modulo_otorgamiento'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 2 THEN 1 ELSE 0 END ) AS validada'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 3 THEN 1 ELSE 0 END ) AS evaluada'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 4 THEN 1 ELSE 0 END ) AS aprobada'),
                    DB::raw("SUM( CASE WHEN b.c367_363_id = '100.00'  THEN 1 ELSE 0 END ) AS aprobadas_al_100"),
                    DB::raw("SUM( CASE WHEN b.c367_363_id = '50.00'  THEN 1 ELSE 0 END ) AS aprobadas_al_50"),
                    DB::raw(' SUM( CASE WHEN b.c367_363_id = 5 THEN 1 ELSE 0 END ) AS rechazada'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 6 THEN 1 ELSE 0 END ) AS deshabilitada'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 7 THEN 1 ELSE 0 END ) AS enviada_a_revisar'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 8 THEN 1 ELSE 0 END ) AS revisada'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 10 THEN 1 ELSE 0 END ) AS solicitud_incompleta'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 11 THEN 1 ELSE 0 END ) AS evaluada_solicitud_incompleta'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 12 THEN 1 ELSE 0 END ) AS aprobada_solicitud_incompleta'),
                    DB::raw('SUM( CASE WHEN b.c367_363_id = 9 THEN 1 ELSE 0 END ) AS borradas'),
                    DB::raw('SUM( CASE WHEN b.c367_renovada = 1 THEN 1 ELSE 0 END ) AS renovadas'),
                    DB::raw('COUNT( b.c367_id ) AS total_de_becas'),

                ]
            )
            ->join('367_BECA_SOLICITUD AS b','b.c367_011_id','=','e.c740_011_id')
            ->where('b.c367_257_id','=',DB::table('257_CICLO_LECTIVO')->max('c257_id'))
            ->where('b.c367_011_id','=',$establecimiento_id)
            ->groupBy('e.c740_011_id')
            ->get();
    }

}
