<?php

namespace Modules\OrdenProviciones\Repositories\V1;

use App\Repository\EloquentRepository;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\DB;
use Modules\OrdenProviciones\Entities\V1\CicloLectivo;
use Modules\OrdenProviciones\Entities\V1\ListadoSolidos;

class ListadoSolidosRepository extends EloquentRepository
{
    public function __construct()
    {
        parent::__construct(new ListadoSolidos());
    }

    public function getListado()
    {
        $list = DB::table('listado_solidos ','l')
            ->select([
                'l.id as id' ,
                'l.nivel_id',
                'l.comedor_cien',
                'l.comedor_cincuenta',
                'l.comedor_docente',
                'l.vianda_cien',
                'l.vianda_cincuenta',
                'l.vianda_docente',
                'l.desayuno_segundo',
                'l.desayuno',
                'l.merienda',
                'l.refrigerio',
                'l.fecha_inicio',
                'l.fecha_modificacion',
                'l.establecimiento_id',
                'l.dias as dias'

            ])
            ->get();
        return $list;
    }

    public function getListadoLacteos()
    {
        $list = DB::table('listado_lacteos ','l')
            ->join('740_ESTABLECIMIENTOS_BECAS AS e','e.c740_codigo','=','l.codigo')
            ->get();
        return $list;
    }



}
