<?php

use Illuminate\Http\Request;
use Modules\OrdenProviciones\Http\Controllers\OrdenProvicionesController;
use Modules\OrdenProviciones\Http\Controllers\ListadoLacteosController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::prefix('v1')->group(function() {
    Route::prefix('orden-provisiones')->group(function() {
        Route::middleware('auth:sanctum')->group(function(){
            Route::get('/listado-solidos', [OrdenProvicionesController::class,'getListadoSolidos']);
            Route::get('/listado-solidos/desayunno-merienda/{id}', [OrdenProvicionesController::class,'getDesayunoMeriendas']);
            Route::get('/listado-solidos/{id}', [OrdenProvicionesController::class,'getListadoByEstablecimiento']);
            Route::get('/datos-establecimiento/{id}', [OrdenProvicionesController::class,'getDatosById']);
            Route::post('/store', [OrdenProvicionesController::class,'store']);
            Route::get('/servicios/{id}', [OrdenProvicionesController::class,'servicios']);
            Route::get('/listado-lacteos',[ListadoLacteosController::class,'index']);
            Route::get('/listado-lacteos/{id}', [ListadoLacteosController::class,'getListadoByEstablecimiento']);
            Route::get('/listado-lacteos/servicios/{id}', [ListadoLacteosController::class,'servicios']);
            Route::post('/listado-lacteos/store', [ListadoLacteosController::class,'store']);
        });
    });
});
