<?php

namespace Modules\OrdenProviciones\Services;

use App\Service\BaseService;
use Modules\OrdenProviciones\Dto\InfoListadoDto;
use Modules\OrdenProviciones\Dto\ListadoLacteoDto;
use Modules\OrdenProviciones\Dto\ListadoSolidoDto;
use Modules\OrdenProviciones\Dto\ServicioFormDto;
use Modules\OrdenProviciones\Entities\V1\EstablecimientoServicios;

class HelperService extends BaseService
{

    /**
     * @param $coleccionServicios
     * @return array
     */
    public function serviciosPorColegio($coleccionServicios):array
    {
        $serviciosPorColegio = [];

        foreach ($coleccionServicios as $servicio)
        {

            $id = $servicio['id'];
            $idColegio = $servicio['establecimiento_id'];
            $beca_id = $servicio['c740_011_id'];
            $nombreServicio = $servicio['servicio'];
            $idServicio = $servicio['servicio_id'];
            $cantidadServicio = $servicio['cantidad'];
            $distrito = $servicio['distrito'];
            $dias = $servicio['dias'];
            $fecha_inicio = $servicio['fecha_inicio'];
            $fecha_modificacion = $servicio['fecha_modificacion'];
            $observacion = $servicio['observacion'];
            $establecimiento = $servicio['establecimiento'];
            $codigo = $servicio['codigo'];
            $nivel_id = $servicio['nivel_id'];
            $empresa = $servicio['empresa'];

            // Si el colegio ya existe en el array, agregamos el servicio y cantidad al array existente
            if (isset($serviciosPorColegio[$idColegio])) {

                $serviciosPorColegio[$idColegio]['id'] = $id;
                $serviciosPorColegio[$idColegio]['beca_id'] = $beca_id;
                $serviciosPorColegio[$idColegio]['establecimiento'] = $establecimiento;
                $serviciosPorColegio[$idColegio]['empresa'] = $empresa;
                $serviciosPorColegio[$idColegio]['codigo'] = $codigo;
                $serviciosPorColegio[$idColegio]['nivel_id'] = $nivel_id;
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['nombre'] = $nombreServicio;
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['servicio_id'] = $idServicio;
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['cantidad'] = $cantidadServicio;
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['dias'] = json_decode($dias);
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['observacion'] = $observacion;
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['establecimiento'] = $establecimiento;
                $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['distrito'] = $distrito;
                $serviciosPorColegio[$idColegio]['distrito'] = $distrito;
                $serviciosPorColegio[$idColegio]['fecha_inicio'] = $fecha_inicio;
                $serviciosPorColegio[$idColegio]['fecha_modificacion'] = $fecha_modificacion;

            } else {
                // Si el colegio no existe en el array, creamos un nuevo array para el colegio
                // e inicializamos los arrays de servicios y cantidades
                $serviciosPorColegio[$idColegio] = array(
                    'id' => $id,
                    'beca_id' => $beca_id,
                    'establecimiento_id' => $idColegio,
                    'establecimiento' => $establecimiento,
                    'empresa' => $empresa,
                    'codigo' => $codigo,
                    'nivel_id'=> $nivel_id,
                    'servicios' => array(
                        $idServicio =>
                            array(
                                'nombre' => $nombreServicio,
                                'servicio_id' => $idServicio,
                                'cantidad'=> $cantidadServicio,
                                'dias'  => json_decode($dias),
                                'observacion' => $observacion,
                                'establecimiento' => $establecimiento,
                                'distrito' => $distrito
                            )
                    ),
                    'distrito' => $distrito,
                    'fecha_inicio' => $fecha_inicio,
                    'fecha_modificacion' => $fecha_modificacion

                );
            }
        }

        return $serviciosPorColegio;

    }

    public function serviciosPorColegioLacteos($coleccionServicios):array
    {
        $serviciosPorColegio = [];

        try {
            foreach ($coleccionServicios as $servicio)
            {

                $id = $servicio['id'];
                $idColegio = $servicio['establecimiento_id'];
                $beca_id = $servicio['c740_011_id'];
                $nombreServicio = $servicio['servicio'];
                $idServicio = $servicio['servicio_id'];
                $cantidadServicio = $servicio['cantidad'];
                $distrito = $servicio['distrito'];
                $dias = $servicio['dias'];
                $fecha_inicio = $servicio['fecha_inicio'];
                $fecha_modificacion = $servicio['fecha_modificacion'];
                $observacion = $servicio['observacion'];
                $establecimiento = $servicio['establecimiento'];
                $codigo = $servicio['codigo'];
                $nivel_id = $servicio['nivel_id'];
                $empresa = $servicio['empresa'];
                $ajuste_consumo_yogur = $servicio['ajuste_consumo_yogur'];
                $porcentaje_ajuste_por_consumo_yogur = $servicio['porcentaje_ajuste_por_consumo_yogur'];
                $ajuste_consumo_leche = $servicio['ajuste_consumo_leche'];
                $porcentaje_ajuste_leche = $servicio['porcentaje_ajuste_leche'];
                $domicilio_entrega = $servicio['domicilio_entrega'];

                // Si el colegio ya existe en el array, agregamos el servicio y cantidad al array existente
                if (isset($serviciosPorColegio[$idColegio])) {

                    $serviciosPorColegio[$idColegio]['id'] = $id;
                    $serviciosPorColegio[$idColegio]['beca_id'] = $beca_id;
                    $serviciosPorColegio[$idColegio]['establecimiento'] = $establecimiento;
                    $serviciosPorColegio[$idColegio]['empresa'] = $empresa;
                    $serviciosPorColegio[$idColegio]['codigo'] = $codigo;
                    $serviciosPorColegio[$idColegio]['nivel_id'] = $nivel_id;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['nombre'] = $nombreServicio;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['servicio_id'] = $idServicio;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['cantidad'] = $cantidadServicio;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['dias'] = json_decode($dias);
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['observacion'] = $observacion;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['establecimiento'] = $establecimiento;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['distrito'] = $distrito;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['ajuste_consumo_yogur'] = $ajuste_consumo_yogur;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['porcentaje_ajuste_por_consumo_yogur'] = $porcentaje_ajuste_por_consumo_yogur;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['ajuste_consumo_leche'] = $ajuste_consumo_leche;
                    $serviciosPorColegio[$idColegio]['servicios'][$idServicio]['porcentaje_ajuste_leche'] = $porcentaje_ajuste_leche;
                    $serviciosPorColegio[$idColegio]['domicilio_entrega'] = $domicilio_entrega;
                    $serviciosPorColegio[$idColegio]['distrito'] = $distrito;
                    $serviciosPorColegio[$idColegio]['fecha_inicio'] = $fecha_inicio;
                    $serviciosPorColegio[$idColegio]['fecha_modificacion'] = $fecha_modificacion;

                } else {
                    // Si el colegio no existe en el array, creamos un nuevo array para el colegio
                    // e inicializamos los arrays de servicios y cantidades
                    $serviciosPorColegio[$idColegio] = array(
                        'id' => $id,
                        'beca_id' => $beca_id,
                        'establecimiento_id' => $idColegio,
                        'establecimiento' => $establecimiento,
                        'empresa' => $empresa,
                        'codigo' => $codigo,
                        'nivel_id'=> $nivel_id,
                        'servicios' => array(
                            $idServicio =>
                                array(
                                    'nombre' => $nombreServicio,
                                    'servicio_id' => $idServicio,
                                    'cantidad'=> $cantidadServicio,
                                    'dias'  => json_decode($dias),
                                    'observacion' => $observacion,
                                    'establecimiento' => $establecimiento,
                                    'distrito' => $distrito,
                                    'ajuste_consumo_yogur' => $ajuste_consumo_yogur,
                                    'porcentaje_ajuste_por_consumo_yogur' => $porcentaje_ajuste_por_consumo_yogur,
                                    'ajuste_consumo_leche' => $ajuste_consumo_leche,
                                    'porcentaje_ajuste_leche' => $porcentaje_ajuste_leche,


                                )
                        ),
                        'domicilio_entrega' => $domicilio_entrega,
                        'distrito' => $distrito,
                        'fecha_inicio' => $fecha_inicio,
                        'fecha_modificacion' => $fecha_modificacion

                    );
                }
            }
        }catch (\Exception $e){
            dd($e->getMessage());
        }

        return $serviciosPorColegio;

    }

    /**
     * @param $serviciosPorColegio
     * @param $collection
     * @return array|mixed|ListadoSolidoDto
     */
    public function setListado($serviciosPorColegio,$collection = true): array |ListadoSolidoDto
    {
        $response = [];

        foreach ($serviciosPorColegio as $servicio)
        {
            $listado = new ListadoSolidoDto($servicio);
            foreach ($servicio['servicios'] as $value)
            {
                $info[]    = new InfoListadoDto($value);

            }
            $listado->setInfo($info);
            unset($info);
            $response[] = $listado;

        }
        return ($collection)?$response:$response[0];
    }


    public function setListadoLacteo($serviciosPorColegio,$collection = true): array |ListadoLacteoDto
    {
        $response = [];

        foreach ($serviciosPorColegio as $servicio)
        {
            $listado = new ListadoLacteoDto($servicio);
            foreach ($servicio['servicios'] as $value)
            {
                $info[]    = new InfoListadoDto($value);

            }
            $listado->setInfo($info);
            unset($info);
            $response[] = $listado;

        }
        return ($collection)?$response:$response[0];
    }


    /**
     * @param $coleccionServicios
     * @return array
     */
    public function serviciosPorColegioHistorico($coleccionServicios):array
    {
        $serviciosPorColegio = [];

        foreach ($coleccionServicios as $servicio) {

            $id = $servicio['id'];
            $ref_id = $servicio['ref_id'];
            $idColegio = $servicio['establecimiento_id'];
            $beca_id = $servicio['c740_011_id'];
            $nombreServicio = $servicio['servicio'];
            $idServicio = $servicio['servicio_id'];
            $cantidadServicio = $servicio['cantidad'];
            $distrito = $servicio['distrito'];
            $dias = $servicio['dias'];
            $fecha_inicio = $servicio['fecha_inicio'];
            $fecha_modificacion = $servicio['fecha_modificacion'];
            $observacion = $servicio['observacion'];
            $establecimiento = $servicio['establecimiento'];
            $codigo = $servicio['codigo'];
            $nivel_id = $servicio['nivel_id'];
            $empresa = $servicio['empresa'];

            // Si el colegio ya existe en el array, agregamos el servicio y cantidad al array existente
            if (isset($serviciosPorColegio[$ref_id])) {

                $serviciosPorColegio[$ref_id]['id'] = $id;
                $serviciosPorColegio[$ref_id]['beca_id'] = $beca_id;
                $serviciosPorColegio[$ref_id]['establecimiento'] = $establecimiento;
                $serviciosPorColegio[$ref_id]['empresa'] = $empresa;
                $serviciosPorColegio[$ref_id]['codigo'] = $codigo;
                $serviciosPorColegio[$ref_id]['nivel_id'] = $nivel_id;
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['nombre'] = $nombreServicio;
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['servicio_id'] = $idServicio;
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['cantidad'] = $cantidadServicio;
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['dias'] = json_decode($dias);
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['observacion'] = $observacion;
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['establecimiento'] = $establecimiento;
                $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['distrito'] = $distrito;
                $serviciosPorColegio[$ref_id]['distrito'] = $distrito;
                $serviciosPorColegio[$ref_id]['fecha_inicio'] = $fecha_inicio;
                $serviciosPorColegio[$ref_id]['fecha_modificacion'] = $fecha_modificacion;

            } else {
                // Si el colegio no existe en el array, creamos un nuevo array para el colegio
                // e inicializamos los arrays de servicios y cantidades
                $serviciosPorColegio[$ref_id] = array(
                    'id' => $id,
                    'beca_id' => $beca_id,
                    'establecimiento_id' => $idColegio,
                    'establecimiento' => $establecimiento,
                    'empresa' => $empresa,
                    'codigo' => $codigo,
                    'nivel_id'=> $nivel_id,
                    'servicios' => array(
                        $idServicio =>
                            array(
                                'nombre' => $nombreServicio,
                                'servicio_id' => $idServicio,
                                'cantidad'=> $cantidadServicio,
                                'dias'  => json_decode($dias),
                                'observacion' => $observacion,
                                'establecimiento' => $establecimiento,
                                'distrito' => $distrito
                            )
                    ),
                    'distrito' => $distrito,
                    'fecha_inicio' => $fecha_inicio,
                    'fecha_modificacion' => $fecha_modificacion

                );
            }
        }

        return $serviciosPorColegio;

    }

    public function serviciosPorColegioLacteosHistorico($coleccionServicios):array
    {
        $serviciosPorColegio = [];

        try {
            foreach ($coleccionServicios as $servicio)
            {

                $id = $servicio['id'];
                $ref_id = $servicio['ref_id'];
                $idColegio = $servicio['establecimiento_id'];
                $beca_id = $servicio['c740_011_id'];
                $nombreServicio = $servicio['servicio'];
                $idServicio = $servicio['servicio_id'];
                $cantidadServicio = $servicio['cantidad'];
                $distrito = $servicio['distrito'];
                $dias = $servicio['dias'];
                $fecha_inicio = $servicio['fecha_inicio'];
                $fecha_modificacion = $servicio['fecha_modificacion'];
                $observacion = $servicio['observacion'];
                $establecimiento = $servicio['establecimiento'];
                $codigo = $servicio['codigo'];
                $nivel_id = $servicio['nivel_id'];
                $empresa = $servicio['empresa'];
                $ajuste_consumo_yogur = $servicio['ajuste_consumo_yogur'];
                $porcentaje_ajuste_por_consumo_yogur = $servicio['porcentaje_ajuste_por_consumo_yogur'];
                $ajuste_consumo_leche = $servicio['ajuste_consumo_leche'];
                $porcentaje_ajuste_leche = $servicio['porcentaje_ajuste_leche'];
                $domicilio_entrega = $servicio['domicilio_entrega'];

                // Si el colegio ya existe en el array, agregamos el servicio y cantidad al array existente
                if (isset($serviciosPorColegio[$ref_id])) {

                    $serviciosPorColegio[$ref_id]['id'] = $id;
                    $serviciosPorColegio[$ref_id]['beca_id'] = $beca_id;
                    $serviciosPorColegio[$ref_id]['establecimiento'] = $establecimiento;
                    $serviciosPorColegio[$ref_id]['empresa'] = $empresa;
                    $serviciosPorColegio[$ref_id]['codigo'] = $codigo;
                    $serviciosPorColegio[$ref_id]['nivel_id'] = $nivel_id;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['nombre'] = $nombreServicio;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['servicio_id'] = $idServicio;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['cantidad'] = $cantidadServicio;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['dias'] = json_decode($dias);
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['observacion'] = $observacion;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['establecimiento'] = $establecimiento;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['distrito'] = $distrito;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['ajuste_consumo_yogur'] = $ajuste_consumo_yogur;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['porcentaje_ajuste_por_consumo_yogur'] = $porcentaje_ajuste_por_consumo_yogur;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['ajuste_consumo_leche'] = $ajuste_consumo_leche;
                    $serviciosPorColegio[$ref_id]['servicios'][$idServicio]['porcentaje_ajuste_leche'] = $porcentaje_ajuste_leche;
                    $serviciosPorColegio[$ref_id]['domicilio_entrega'] = $domicilio_entrega;
                    $serviciosPorColegio[$ref_id]['distrito'] = $distrito;
                    $serviciosPorColegio[$ref_id]['fecha_inicio'] = $fecha_inicio;
                    $serviciosPorColegio[$ref_id]['fecha_modificacion'] = $fecha_modificacion;

                } else {
                    // Si el colegio no existe en el array, creamos un nuevo array para el colegio
                    // e inicializamos los arrays de servicios y cantidades
                    $serviciosPorColegio[$ref_id] = array(
                        'id' => $id,
                        'beca_id' => $beca_id,
                        'establecimiento_id' => $idColegio,
                        'establecimiento' => $establecimiento,
                        'empresa' => $empresa,
                        'codigo' => $codigo,
                        'nivel_id'=> $nivel_id,
                        'servicios' => array(
                            $idServicio =>
                                array(
                                    'nombre' => $nombreServicio,
                                    'servicio_id' => $idServicio,
                                    'cantidad'=> $cantidadServicio,
                                    'dias'  => json_decode($dias),
                                    'observacion' => $observacion,
                                    'establecimiento' => $establecimiento,
                                    'distrito' => $distrito,
                                    'ajuste_consumo_yogur' => $ajuste_consumo_yogur,
                                    'porcentaje_ajuste_por_consumo_yogur' => $porcentaje_ajuste_por_consumo_yogur,
                                    'ajuste_consumo_leche' => $ajuste_consumo_leche,
                                    'porcentaje_ajuste_leche' => $porcentaje_ajuste_leche,


                                )
                        ),
                        'domicilio_entrega' => $domicilio_entrega,
                        'distrito' => $distrito,
                        'fecha_inicio' => $fecha_inicio,
                        'fecha_modificacion' => $fecha_modificacion

                    );
                }
            }
        }catch (\Exception $e){
            dd($e->getMessage());
        }

        return $serviciosPorColegio;

    }

    /**
     * @param $servicios
     * @param $establecimiento_id
     * @return ServicioFormDto
     */
    public function setFormServicios($servicios,$establecimiento_id):ServicioFormDto
    {
        $form = new ServicioFormDto();
        $form->setEstablecimientoId($establecimiento_id);
        foreach ($servicios as $servicio){
            if($servicio->getServicioId() == 1)
            {
                $form->setCantidadRefrigerio($servicio->getCantidad());
                $form->setDiasRefrigerio($servicio->getDias());
            }

            if($servicio->getServicioId() == 2)
            {
                $form->setCantidadDesayuno($servicio->getCantidad());
                $form->setDiasDesayuno($servicio->getDias());
            }
            if($servicio->getServicioId() == 3)
            {
                $form->setCantidadMerienda($servicio->getCantidad());
                $form->setDiasMerienda($servicio->getDias());
            }
            if($servicio->getServicioId() == 4)
            {
                $form->setCantidadCmd100($servicio->getCantidad());
                $form->setDiasCmd100($servicio->getDias());
            }
            if($servicio->getServicioId() == 5)
            {
                $form->setCantidadCmd50($servicio->getCantidad());
                $form->setDiasCmd50($servicio->getDias());
            }
            if($servicio->getServicioId() == 6)
            {
                $form->setCantidadCmdDocente($servicio->getCantidad());
                $form->setDiasCmdDocente($servicio->getDias());
            }
            if($servicio->getServicioId() == 7)
            {
                $form->setCantidadVnd100($servicio->getCantidad());
                $form->setDiasVnd100($servicio->getDias());
            }

            if($servicio->getServicioId() == 8)
            {
                $form->setCantidadVnd50($servicio->getCantidad());
                $form->setDiasVnd50($servicio->getDias());
            }

            if($servicio->getServicioId() == 9)
            {
                $form->setCantidadVndDocente($servicio->getCantidad());
                $form->setDiasVndDocente($servicio->getDias());
            }

            if($servicio->getServicioId() == 10)
            {
                $form->setCantidadDesayunoSeg($servicio->getCantidad());
                $form->setDiasDesayunoSeg($servicio->getDias());
            }
        }

        return $form;
    }

    /**
     * @return int
     */
    public function getRefId():int
    {
        $ref_id = EstablecimientoServicios::max("ref_id");

        if (is_null($ref_id))        {
            $ref_id = 1;
        }else{
            $ref_id++;
        }

        return $ref_id;
    }

}
