<?php

namespace App\Console\Commands;

use App\Entities\Eloquent\CicloLectivo;
use Illuminate\Console\Command;
use Modules\OrdenProviciones\Entities\V1\EstablecimientoServicios;
use Modules\OrdenProviciones\Repositories\V1\ListadoSolidosRepository;

class CrearServicios extends Command
{
    protected $listado_repo;
    const SERVICIOS = ['comedor_cien','comedor_cincuenta','comedor_docente','vianda_cien','vianda_cincuenta',
        'vianda_docente','desayuno_segundo','desayuno','merienda','refrigerio'];
    public function __construct(ListadoSolidosRepository $listadoSolidosRepository)
    {
        parent::__construct();
        $this->listado_repo = $listadoSolidosRepository;
    }

    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'app:crear-servicios';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Carga los servicios por establecimiento para el listado de solidos';

    /**
     * Execute the console command.
     */
    public function handle()
    {
        $datos = $this->listado_repo->getListado();
        $ciclo_lectivo_id = CicloLectivo::max("c257_id");

        foreach ($datos as $dato)
        {
            foreach ($dato as $key => $value){

                if (in_array($key,self::SERVICIOS)){
                    $servicio = new EstablecimientoServicios();
                    $servicio->establecimiento_id = $dato->establecimiento_id;
                    $servicio->nivel_id = $dato->nivel_id;
                    $servicio->servicio_id = $this->getServicio($key);
                    $servicio->cantidad = $value;
                    $servicio->dias = $this->setDias($dato->dias);
                    $servicio->listado_id = 1;
                    $servicio->vigente = 1;
                    $servicio->fecha_inicio = $dato->fecha_inicio;
                    $servicio->fecha_modificacion = $dato->fecha_modificacion;
                    $servicio->ciclo_lectivo_id = $ciclo_lectivo_id;
                    $servicio->save();
                }

            }


        }
        dd('TERMINO');
    }

    public function setDias($dias)
    {
        $dias_arr = json_decode($dias);

        $dias_selecionados = [];
        if (!is_null($dias_arr))
        {
            foreach ($dias_arr as $key => $value){
                $dias_selecionados[] = $value;
            }
        }

        return json_encode($dias_selecionados);
    }
    private function getServicio($servicio)
    {
        switch ($servicio){
            case 'comedor_cien':
                return 4;
                break;
            case 'comedor_cincuenta':
                return 5;
                break;
            case 'comedor_docente':
                return 6;
                break;
            case 'vianda_cien':
                return 7;
                break;
            case 'vianda_cincuenta':
                return 8;
                break;
            case 'vianda_docente':
                return 9;
                break;
            case 'desayuno_segundo':
                return 10;
                break;
            case 'desayuno':
                return 2;
                break;
            case 'merienda':
                return 3;
                break;
            case 'refrigerio':
                return 1;
                break;


        }
    }
}
