<?php

namespace App\Console\Commands;

use App\Entities\Eloquent\CicloLectivo;
use Illuminate\Console\Command;
use Modules\OrdenProviciones\Entities\V1\EstablecimientoServicios;
use Modules\OrdenProviciones\Repositories\V1\EstablecimientoServiciosRepository;
use Modules\OrdenProviciones\Repositories\V1\ListadoSolidosRepository;

class CrearServiciosLacteos extends Command
{
    const SERVICIOS = ['litros_diarios','leche_semanal','litros_leche_semanal_descremada','yogur_semanal','yogur_diario',
        'litros_yogur_semanal_descremada','litros_semanales_sin_lactosa','bb1_unidades_semanal','bb2_unidades_semanal'];
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'app:crear-servicios-lacteos';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    protected $establecimiento_servicios;
    public function __construct(ListadoSolidosRepository $establecimiento_servicios)
    {
        parent::__construct();
        $this->establecimiento_servicios = $establecimiento_servicios;

    }

    public function handle()
    {
        $datos = $this->establecimiento_servicios->getListadoLacteos();

        $ciclo_lectivo_id = CicloLectivo::max("c257_id");
        $cnt = 1;
        foreach ($datos as $dato) {
            $this->info("Procesando {$cnt}");
            foreach ($dato as $key => $value) {

                if (in_array($key, self::SERVICIOS))
                {
//                    dd($dato->litros_diarios);
                    $datos_servicio = $this->getServicio($key,$dato);
//                    dd($datos_servicio);
                    $servicio = new EstablecimientoServicios();
                    $servicio->establecimiento_id = $dato->c740_id;
                    $servicio->nivel_id = $dato->c740_nivel;
                    $servicio->servicio_id = $datos_servicio['servicio_id'];
                    $servicio->cantidad = $datos_servicio['cantidad'];
                    $servicio->dias = $datos_servicio['dias'];
                    $servicio->listado_id = 2;
                    $servicio->vigente = 1;
                    $servicio->fecha_inicio = $dato->fecha;

                    $servicio->ajuste_consumo_yogur = $datos_servicio['ajuste_consumo_yogur'];
                    $servicio->porcentaje_ajuste_por_consumo_yogur = $datos_servicio['porcentaje_ajuste_por_consumo_yogur'];
                    $servicio->ajuste_consumo_leche = $datos_servicio['ajuste_consumo_leche'];
                    $servicio->porcentaje_ajuste_leche = $datos_servicio['porcentaje_ajuste_leche'];
                    $servicio->ciclo_lectivo_id = $ciclo_lectivo_id;

                    $servicio->domicilio_entrega = $dato->domicilio_entrega;
                    $servicio->save();
                }
            }
            $cnt++;

        }
        dd('TERMINO');
    }

    public function setDias($dias)
    {
        $dias_arr = json_decode($dias);

        $dias_selecionados = [];
        if (!is_null($dias_arr)) {
            foreach ($dias_arr as $key => $value) {
                $dias_selecionados[] = $value;
            }
        }

        return json_encode($dias_selecionados);
    }

    private function getServicio($servicio,$dato)
    {
        switch ($servicio) {
            case 'litros_diarios':
                return [
                   'servicio_id' => 19,
                   'dias' => null,
                    'cantidad' => $dato->litros_diarios,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;

                break;
            case 'leche_semanal':
                return [
                    'servicio_id' => 20,
                    'dias' => $dato->dias_entrega_leche,
                    'cantidad' => $dato->leche_semanal,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => $dato->ajuste_leche,
                    'porcentaje_ajuste_leche' => $dato->porcentaje_ajuste_leche

                ] ;


                break;
            case 'litros_leche_semanal_descremada':
                return [
                    'servicio_id' => 11,
                    'dias' => null,
                    'cantidad' => $dato->litros_leche_semanal_descremada,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' =>null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;


                break;
            case 'yogur_semanal':
                return [
                    'servicio_id' => 13,
                    'dias' => $dato->dias_entrega_yougur,
                    'cantidad' => $dato->yogur_semanal,
                    'ajuste_consumo_yogur' => $dato->ajuste_consumo_yogur,
                    'porcentaje_ajuste_por_consumo_yogur' => $dato->porcentaje_ajuste_por_consumo_yogur,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;

                break;
            case 'yogur_diario':
                return [
                    'servicio_id' => 12,
                    'dias' => $dato->dias_entrega_yougur,
                    'cantidad' => $dato->dias_consumo_yogur,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;

                break;
            case 'litros_yogur_semanal_descremada':
                return [
                    'servicio_id' => 14,
                    'dias' => null,
                    'cantidad' => $dato->litros_yogur_semanal_descremada,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;

                break;
            case 'litros_semanales_sin_lactosa':
                return [
                    'servicio_id' => 16,
                    'dias' => null,
                    'cantidad' => $dato->litros_semanales_sin_lactosa,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;
                break;
            case 'bb1_unidades_semanal':
                return [
                    'servicio_id' => 17,
                    'dias' => null,
                    'cantidad' => $dato->bb1_unidades_semanal,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;

                break;
            case 'bb2_unidades_semanal':
                return [
                    'servicio_id' => 18,
                    'dias' => null,
                    'cantidad' => $dato->bb2_unidades_semanal,
                    'ajuste_consumo_yogur' => null,
                    'porcentaje_ajuste_por_consumo_yogur' => null,
                    'ajuste_consumo_leche' => null,
                    'porcentaje_ajuste_leche' => null
                ] ;

                break;
        }
    }
}
