<?php

namespace App\Entities\Eloquent;

use Illuminate\Auth\Passwords\CanResetPassword as CanResetPass;
use Illuminate\Contracts\Auth\CanResetPassword;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class SfUsers extends Authenticatable implements CanResetPassword
{
    use HasApiTokens,Notifiable, CanResetPass;
    protected $table = 'sf_guard_user';
    public $timestamps = false;

    protected $primaryKey = "id";
    protected $guarded = ['id'];

    protected $fillable = [
        'first_name',
        'last_name',
        'email_address',
        'username',
        'algorithm',
        'salt',
        'password',
        'pass',
        'is_active',
        'is_super_admin',
        'last_login',
        'created_at',
        'updated_at'

    ];

    public function getAuthPassword()
    {
        return $this->pass;
    }
}
