<?php

namespace App\Extensions\Auth;

use Illuminate\Auth\GuardHelpers;
use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Contracts\Auth\Guard;
use Illuminate\Contracts\Auth\UserProvider;
use Illuminate\Http\Request;


class SfGuardUser implements Guard
{
    use GuardHelpers;
    private $request;
    private $username;
    private $password;

    const SF_GUARD_USER = 'wsad';
    public function __construct(UserProvider $provider, Request $request,$configuration)
    {
//        dd($this->provider);
        $this->provider = $provider;
        $this->request = $request;

        // key to check in request
        $this->username = isset($configuration['username']) ? $configuration['username'] : 'username';
        $this->password = isset($configuration['password']) ? $configuration['password'] : 'password';
    }

    public function attempt(array $credentials = [])
    {
        $user = $this->provider->retrieveByCredentials($credentials);

        if ($this->hasValidCredentials($user, $credentials))
        {

            $this->user = $user;
            return true;
        }

        return false;
    }

    public function attemptByUser(array $credentials = [])
    {
        $user = $this->provider->retrieveByCredentialsId($credentials);
        $this->user = $user;

        return true;
    }

    public function check()
    {
        // TODO: Implement check() method.
    }

    public function guest()
    {
        // TODO: Implement guest() method.
    }




    public function getCredentialsFromRequest()
    {
        $credentials['username'] = $this->request->get($this->username);
        $credentials['password'] = $this->request->get($this->password);

        if (empty($credentials)) {
            return null;
        }

        return $credentials;
    }

    public function id()
    {
        // TODO: Implement id() method.
    }

    public function user()
    {
        if (!is_null($this->user)) {
            return $this->user;
        }
        $user = null;

        $credentials = $this->getCredentialsFromRequest();
        if (!empty($credentials)) {
            $user = $this->provider->retrieveByCredentials($credentials);
        }
        return $this->user = $user;
    }

    public function validate(array $credentials = [])
    {
        if (empty($credentials[$this->username]) || empty($credentials[$this->password])) {
            return false;
        }
        $credentials = [ $this->storageKey => $credentials[$this->password] ];
        if ($this->provider->retrieveByCredentials($credentials)) {
            return true;
        }
        return false;
    }

    public function hasUser()
    {
        // TODO: Implement hasUser() method.
    }

    public function setUser(Authenticatable $user)
    {
        $this->user = $user;
    }

    /**
     * Determine if the user matches the credentials.
     *
     * @param  mixed  $user
     * @param  array  $credentials
     * @return bool
     */
    protected function hasValidCredentials($user, $credentials)
    {
        return ! is_null($user) && $this->provider->validateCredentials($user, $credentials);
    }

}
