<?php

namespace App\Extensions\Auth;

use App\Entities\Eloquent\SfUsers;
use App\Exceptions\UnauthorizedException;
use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Contracts\Auth\UserProvider;
use Illuminate\Support\Facades\Hash;

class SfGuardUserProvider implements UserProvider
{
    private $user;

    public function __construct(SfUsers $user)
    {
        $this->user = $user;
    }


    public function retrieveById($identifier)
    {
        return $this->user->find($identifier);
    }

    public function retrieveByToken($identifier, $token)
    {
        // TODO: Implement retrieveByToken() method.
    }

    public function updateRememberToken(Authenticatable $user, $token)
    {
        // TODO: Implement updateRememberToken() method.
    }

    public function retrieveByCredentials(array $credentials)
    {
        $username = $credentials['username'];
        $password = $credentials['password'];

        $user_wsad = SfUsers::where('username',$username)->first();

        if($user_wsad) {
            // Valido Password de Wsad
            $this->validatePasswordWsad($user_wsad,$password);
        }

        return $user_wsad;

    }

    public function retrieveByCredentialsId(array $credentials)
    {
        $id = $credentials['id'];

       return SfUsers::where('id',$id)->first();

    }

    private function validatePasswordWsad($user_wsad,$password)
    {

        if ($user_wsad->algorithm == 'sha1')
        {
            $password_check = sha1($user_wsad->salt.$password);
        }else{
            $password_check = md5($user_wsad->salt.$password);
        }

        if ($user_wsad->password == $password_check)
        {
            // Si no tiene el password nuevo se los seteo para hacer el attempt
            if (!$user_wsad->pass)
            {
                $user_wsad->pass = bcrypt($password);
                $user_wsad->save();
            }
        }
    }

    public function validateCredentials(Authenticatable $user, array $credentials)
    {
        $username = $credentials['username'];
        $pass = $credentials['password'];
        return   ($username == $user->username &&  Hash::check($pass,$user->pass) && $user->is_active )? true : false;
    }
}
