<?php

namespace App\Http\Requests;

use App\Http\Middleware\DatabaseSwitcher;
use App\Rules\Search\SearchRule;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\JsonResponse;
use Illuminate\Validation\Rule;


class AsiganturasSearchRequest extends FormRequest
{
    public function response(array $errors) {

        return new JsonResponse($errors, 422);
    }


    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {

    return [

            'c010_id' => [new SearchRule('nullable|integer')],
            'c010_des' => [new SearchRule('nullable|string')],
            'c010_plan_de_estudio' => [new SearchRule('nullable|string')],
            'c010_grupo_educacion_fisica' => [new SearchRule('nullable|string')],
            'c010_activo' => [new SearchRule('nullable|boolean')],
            'c010_fechadesactivo' => [new SearchRule('nullable|string')],
            'c010_duplicados' => [new SearchRule('nullable|string')],
            'c010_abreviatura' => [new SearchRule('nullable|string')],
            'c010_admite_horas_a_termino' => [new SearchRule('nullable|string')],



        ];
    }

    public function messages()
    {
        return [ ];
    }

    public function attributes()
    {
        return [ ];
    }



}
