<?php

namespace App\Http\Requests;

use App\Http\Middleware\DatabaseSwitcher;
use App\Rules\Search\SearchRule;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\JsonResponse;
use Illuminate\Validation\Rule;


class CaracteresSearchRequest extends FormRequest
{
    public function response(array $errors) {

        return new JsonResponse($errors, 422);
    }


    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {

    return [

            'c156_id' => [new SearchRule('nullable|string')],
            'c156_des' => [new SearchRule('nullable|string')],

        ];
    }

    public function messages()
    {
        return [ ];
    }

    public function attributes()
    {
        return [ ];
    }



}
