<?php

namespace App\Http\Requests;

use App\Http\Middleware\DatabaseSwitcher;
use App\Rules\Search\SearchRule;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\JsonResponse;
use Illuminate\Validation\Rule;


class CargosSearchRequest extends FormRequest
{
    public function response(array $errors) {

        return new JsonResponse($errors, 422);
    }


    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {

    return [

            'c030_id' => [new SearchRule('nullable|integer')],
            'c030_des' => [new SearchRule('nullable|string')],
            'c030_031_id' => [new SearchRule('nullable|integer')],
            'c030_032_id' => [new SearchRule('nullable|integer')],
            'c030_001_id' => [new SearchRule('nullable|integer')],
            'c030_077_id' => [new SearchRule('nullable|integer')],
            'c030_cargahoraria' => [new SearchRule('nullable|float')],
            'c030_puntoindice' => [new SearchRule('nullable|integer')],

        ];
    }

    public function messages()
    {
        return [ ];
    }

    public function attributes()
    {
        return [ ];
    }



}
