<?php

namespace App\Http\Resources;

use Illuminate\Http\Resources\Json\JsonResource;


class FtResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {

        return [
            'id' => $this->c079_id,
            'fecha_toma_de_posecion' => $this->c079_fecha_toma_de_posecion ,
            'fecha_baja' => $this->c079_fecha_baja ,
            'impresa' => $this->c079_impresa ,
            'marca' => $this->c079_marca ,
            'caracter' => $this->c079_caracter ,
            'tipo' => $this->c079_tipo ,
            'sial' => $this->c079_sial ,
            'numero_de_orden' => $this->c079_numero_de_orden ,
            'puntaje' => $this->c079_puntaje ,
            'fecha_de_la_propuesta' => $this->c079_fecha_de_la_propuesta ,
            'numero_de_baja' => $this->c079_numero_de_baja ,
            'nota' => $this->c079_nota ,
            'orden_concurso' => $this->c079_orden ,
            'numero_baja' => $this->c079_numero_baja ,
            'anio_baja' => $this->c079_anio_baja ,
            'sigla_baja' => $this->c079_sigla_baja ,
            'fecha_carga' => $this->c079_fecha_carga ,
            'listado' => $this->c079_listado ,
            'fecha_carga_toma_de_posesion' => $this->c079_fecha_carga_toma_de_posesion ,
            'fecha_carga_baja' => $this->c079_fecha_carga_baja ,
            'nota_licencia' => $this->c079_nota_licencia ,
            'aprobado_por_supervision' => $this->c079_aprobado_por_supervision ,
            'en_emergencia' => $this->c079_en_emergencia ,
            'art_66L' => $this->c079_art66 ,
            'fecha_envio_direccion_de_area' => $this->c079_fecha_envio_direccion_de_area ,
            'licencia_mayor_treinta_dias' => $this->c079_licencia_mayor_treinta_dias ,
            'id_rol_meta4' => $this->c079_id_rol ,
            'con_continuidad_pedagogica' => $this->c079_con_continuidad_pedagogica ,
            'fecha_baja_termino' => $this->c079_fecha_baja_termino ,
            'usuario_propone_docente' => $this->c079_usuario_propone_docente ,
            'horas' => $this->c079_horas ,
            'notax' => $this->c079_notax , // todo: revisar de donde viene.
            'email_response' => $this->c079_email_response ,
            'id_ft_anterior' => $this->c079_079_anterior_id ,
            'id_formut_continuidad' => $this->c079_id_formut_continuidad , // id al ft que tiene la continuidad pedagogica.
            'c079_034_id' => $this->c079_034_id , //pof
            'oriAcceso' => new OriAccesoResource(
                $this->whenLoaded('oriAcceso')
            ),
            'oriVacante' => new OriVacanteResource(
                $this->whenLoaded('oriVacante')
            ),
            'oriLicencia' => new OriLicenciaResource(
                $this->whenLoaded('oriLicencia')
            ),
            'oriCese' => new OriCeseResource(
                $this->whenLoaded('oriCese')
            ),
            'origen' => new OrigenResource(
                $this->whenLoaded('origen')
            ),
            'persona' => new PersonaResource(
                $this->whenLoaded('persona')
            ),
            'personaReemplazada' => new PersonaResource(
                $this->whenLoaded('personaReemplazada')
            ),
            'normaBaja' => new NormaResource(
                $this->whenLoaded('normaBaja')
            ),
            'normaTomaPosecion' => new NormaResource(
                $this->whenLoaded('normaTomaPosecion')
            ),
            'asignatura' => new AsignaturaResource(
                $this->whenLoaded('asignatura')
            ),


            'c079_066_id' => $this->c079_066_id , //Servicio
            'c079_264_id' => $this->c079_264_id , //FtEstado
            'c079_755_id' => $this->c079_755_id , //EspecialidadAsignatura


        ];

    }
}
