<?php

namespace App\Http\Resources;

use App\Http\Resources\PofResource;
use App\Models\Titularizacion;
use App\Models\TitularizacionFormulario;
use Illuminate\Http\Resources\Json\JsonResource;
use DB;
class PersonaResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {





        return [
            'id' => $this->c020_id,
            'documento' => $this->c020_documento ,
            'sexo' => $this->c020_sexo ,
            'apellido_nombre' => $this->c020_ayn,
            'apellido_casada' => $this->c020_apcasada,
            'fecha_nacimiento' => $this->c020_fnac,
            'domicilio' => $this->c020_domic,
            'telefono' => $this->c020_telefon,
            'cp' => $this->c020_cp,
            'ficha_municipal' => $this->c020_fm,
            'domicilio_caba' => $this->c020_domicilio_caba,
            'cp_caba' => $this->c020_cp_caba,
            'cedula' => $this->c020_cedula,
            'policia' => $this->c020_policia,
            'estado_civil' => $this->c020_ecivil,
            'opcion' => $this->c020_opcion,
            'nacion' => $this->c020_nacion,
            'jubilacion' => $this->c020_jub,
            'fecha_jubilacion' => $this->c020_fjub,
            'pension' => $this->c020_pension,
            'caja_previsional' => $this->c020_cajapre,
            'apto_medico' => $this->c020_apto,
            'fecha_apto_medico' => $this->c020_fapto,
            'apto_medico_remitido' => $this->c020_aptor,
            'reincidencia' => $this->c020_reinc,
            'fecha_reincidencia' => $this->c020_freinc,
            'cuil' => $this->c020_cuil,
            'intimacion_jubilacion' => $this->c020_intim,
            'dispocicion_intimacion_jubilacion' => $this->c020_disinti,
            'anio_dispocicion_intimacion_jubilacion' => $this->c020_disainti,
            'fecha_remision' => $this->c020_fremis,
            'nota' => utf8_encode($this->c020_memo),
            'tipo_documento' => $this->c020_tdoc,
            'nota_renuncia_condicionada' => utf8_encode($this->c020_obsrencon),
            'photo' => $this->c020_imagen,
            'discapacitado' => $this->c020_discapacitado,
            'certificado_discapacidad' => $this->c020_certificado,
            'lugar_nacimiento' => $this->c020_lugarnacimiento,
            'anios_residencia' => $this->c020_anosresidencia,
            'fallecido' => $this->c020_fallecido,
            'fecha_fallecido' => $this->c020_ffallecido,
            'email' => $this->c020_mail,
            'celular' => $this->c020_celular,
            'telefono_titularizacion' => $this->c020_telefonotitularizacion,
            'mail_titularizacion' => $this->c020_mail_titularizacion,
            'apto_titularizacion' => $this->c020_apto_titularizacion,
            'fecha_apto_medico_titularizacion' => $this->c020_fapto_titularizacion,
            'nota_inhibicion' => utf8_encode($this->c020_memoinhibicion),
            'id_liquidacion_haberes' => $this->c020_idhr,
            'segundo_nombre' => $this->c020_segundo_nombre,
            'no_docente' => $this->c020_nd,
            'mail_alternativo' => $this->c020_mailalternativo,
            'nombre' => $this->c020_apellido,
           // 'pof' =>PofResource::collection($this->whenLoaded('pofs')),
             //  'localidad' => $this->c020_loca, //todo: c020_117_id
            'localidad' => new LocalidadResource(
                $this->whenLoaded('localidad')
            ),
            'provincia' => new ProvinciaResource(
                $this->whenLoaded('provincia')
            ),
            'origen' => new OrigenResource(
                $this->whenLoaded('origen')
            ),
            'nacionalidad' => new NacionalidadResource(
                $this->whenLoaded('nacionalidad')
            ),
            'estadoCivil' => new EstadoCivilResource(
                $this->whenLoaded('estadoCivil')
            ),
            'titProf' => new TitProfResource(
                $this->whenLoaded('titProf')
            ),
            'estudioNd' => new EstudioNdResource(
                $this->whenLoaded('estudioNd')
            ),
            'tipoDiscapacidad' => new TipoDiscapacidadResource(
                $this->whenLoaded('tipoDiscapacidad')
            ),
            'tipoDoc' => new TipoDocResource(
                $this->whenLoaded('tipoDoc')
            ),
            'tipoGenero' => new TipoGeneroResource(
                $this->whenLoaded('tipoGenero')
            ),
           // 'titular' =>PofResource::collection($this->whenLoaded('titular')),
        ];

    }
}
