<?php

namespace App\Http\Resources;

use App\Models\Caracter;
use Illuminate\Http\Resources\Json\JsonResource;
use DB;

class ServicioResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {
        $horas_147= $this->c066_horas;
        if(empty($horas_147) || $horas_147 ==0 ){
            $sql_horas_147="select c147_cargahoraria as horas from 147_CARGA_HORARIA  where   c147_012_id = '".$this->establecimiento->c011_012_id ."' and c147_030_id = ".$this->cargo->c030_id ." and   c147_035_id  ".$this->cargo->c030_035_id ."  limit 1 ";
            $rows= (DB::select($sql_horas_147));
            if(( isset($rows[0]) && $rows[0]->horas > 0 ) )
                $horas_147 = $rows[0]->horas;
        }
        if(empty($horas_147) || $horas_147 ==0 ){
            $sql_horas_147="select c147_cargahoraria as horas from 147_CARGA_HORARIA  where c147_030_id = ".$this->cargo->c030_id ." and   c147_035_id  ".$this->cargo->c030_035_id ."  limit 1 ";
            $rows= (DB::select($sql_horas_147));
            if(( isset($rows[0]) && $rows[0]->horas > 0 ) )
                $horas_147 = $rows[0]->horas;
        }


        $caracterObj = Caracter::where('c156_id', $this->c066_caracter)->first();
        return [
            'id' => $this->c066_id,
            'caracter_id' => $this->c066_caracter ,
            'caracter' => is_null($caracterObj)?'': new CaracterResource($caracterObj),
            'tipo_cargo' => "066",
            'fecha_toma_posecion' => $this->c066_fcmzo->format('d/m/Y'),
            'fecha_cese' => $this->c066_fcese ,
            'cuatrimestre' => $this->c066_cuat ,
            'comision' => $this->c066_comision ,
            'anio' => $this->c066_ano ,
            'division' => $this->c066_div ,
            'grupo_educacion_fisica' => $this->c066_gef ,
            'horas' => $this->c066_horas ,
            'curso' => $this->c066_curso ,
            'trabajado' => $this->c066_trabajado ,
            'fecha_trabajado' => $this->c066_fecha_trabajado ,
            'marca' => $this->c066_marca ,
            'migrado' => $this->c066_migrado ,
            'horas_a_termino' => $this->c066_horasatermino ,
            'creacion' => $this->c066_creacion ,
            'fecha_cese_uin' => $this->c066_fceseuin ,
            'nopof' => $this->c066_nopof ,
            'movimiento' => $this->c066_movimiento ,
            'disponibilidad' => $this->c066_disponibilidad ,
            'ubicacion' => $this->c066_ubic ,
            'titulariza' => $this->c066_titulariza ,
            'readmitido' => $this->c066_readmitido ,
            'afectado' => $this->c066_afectado ,
            'es_dhc' =>   ($this->cargo->c030_031_id == 1 &&  $this->cargo->c030_032_id == 'PR' &&  !in_array($this->cargo->c030_id ,array(1504,1507, 1528, 1549, 1550 )  )) || $this->cargo->c030_id == 9883,
            'es_tp_tc_pmea' =>   in_array($this->cargo->c030_id ,array(1504,1507, 1528, 1549, 1550,9883)  ),
            'es_tp_tc' =>        in_array($this->cargo->c030_id ,array(1504,1507, 1528, 1549, 1550)  ),
            'es_jc' =>  $this->c034_035_id1 = 7 && in_array($this->c034_030_id, array(2486,3442,612,2414,1089,1058,2389,1055,9107,9968,9109,9105,3520,3521,3523,1020,315,1057,1040,57,59)),
            'es_conduccion' => ( $this->cargo->c030_031_id == 2) ,
            '147_horas' => $horas_147 ,
            'oriAcceso' => new OriAccesoResource(
                $this->whenLoaded('oriAcceso')
            ),
            'oriVacante' => new OriVacanteResource(
                $this->whenLoaded('oriVacante')
            ),
            'oriLicencia' => new OriLicenciaResource(
                $this->whenLoaded('oriLicencia')
            ),
            'oriCese' => new OriCeseResource(
                $this->whenLoaded('oriCese')
            ),

            'normaAlta' => new NormaResource(
                $this->whenLoaded('normaAlta')
            ),
            'normaBaja' => new NormaResource(
                $this->whenLoaded('normaBaja')
            ),
            'normaBajaUin' => new NormaResource(
                $this->whenLoaded('normaBajaUin')
            ),
            'normaProv' => new NormaResource(
                $this->whenLoaded('normaProv')
            ),
            'normaBajaExpedienteElectronico' => new NormaResource(
                $this->whenLoaded('normaBajaExpedienteElectronico')
            ),
            'normaAltaExpedienteElectronico' => new NormaResource(
                $this->whenLoaded('normaAltaExpedienteElectronico')
            ),
            'asignatura' => new AsignaturaResource(
                $this->whenLoaded('asignatura')
            ),
            'turno' => new TurnoResource(
                $this->whenLoaded('turno')
            ),
            'turno2' => new TurnoResource(
                $this->whenLoaded('turno2')
            ),

            '071_id' => $this->c066_071_id , //todo
            '020_id_uin' => $this->c066_020_id_uin ,
            'c066_034_id' => $this->c066_034_id , //pof
            '461_id' => $this->c066_461_id ,
            'c066_020_id_des' => $this->c066_020_id_des , //   persona propuesta
            'c066_020_id_rem' => $this->c066_020_id_rem , //   persona reemplaza
            'establecimiento' => new EstablecimientoResource(
                $this->whenLoaded('establecimiento')
            ),
            'area' => $this->when(($this->establecimiento && $this->establecimiento->area), new AreaResource($this->establecimiento->area)),
            'cargo' => new CargoResource(
                $this->whenLoaded('cargo')
            ),
            'plan' => new PlanResource(
                $this->whenLoaded('plan')
            ),
            'tramo' => new TramoResource(
                $this->whenLoaded('tramo')
            ),
        ];

    }
}
