<?php

namespace App\Http\Resources;


use App\Models\Persona;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Support\Carbon;


class TitularizacionFormularioResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {

        return [
            'id' => $this->c833_id,
            'persona_id' => $this->c833_020_id,
            'creado' => Carbon::parse($this->c833_creado)->format('d/m/Y '),
            'modificado' =>  Carbon::parse($this->c833_modificado)->format('d/m/Y H:i'),
           // 'cargos' => json_decode($this->c833_json_cargos),
            'estado_id' => $this->c833_832_id,
            'expediente' => $this->c833_expediente,
            'estado' => new TitularizacionEstadoResource(
                $this->whenLoaded('estado')
            ),
            'norma' => new NormaResource(
                $this->whenLoaded('norma')
            ), 'persona' => new PersonaResource(
                $this->whenLoaded('persona')
            ),
        ];
    }
}
