<?php

namespace App\Http\Resources;


use App\Models\Persona;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Support\Carbon;


class TitularizacionResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {

        return [
            'id' => $this->c830_id,
            'persona_id' => $this->c830_020_id,
            'validada' => $this->c830_situacion_validada,
            'creado' => Carbon::parse($this->c830_creado)->format('d/m/Y  H:i'),
            'modificado' =>  Carbon::parse($this->c830_modificado)->format('d/m/Y H:i'),
            'cargos' => json_decode($this->c830_situacion_revista_json),
            'tiene_apto' => $this->c830_tiene_apto_medico,
            'tiene_apto_desc' => $this->c830_tiene_apto_medico=='1'?'Tiene apto médico':'Sin apto médico',
            'persona' => new PersonaResource(
                $this->whenLoaded('persona')
            ),
        ];
    }
}
