<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class CargosMeta4 extends Model
{
    protected $table = '319_CARGOSFTMETA4';

    public function turno() {
        return $this->hasOne(Turno::class, 'c035_id', 'c319_035_id');
    }

    public function cargo() {
        return $this->hasOne(Cargo::class, 'c030_id', 'c319_030_id');
    }

    public function modalidad() {
        return $this->hasOne(Modalidad::class, 'c012_id', 'c319_012_id');
    }
    public function junta() {
        return $this->hasOne(Modalidad::class, 'c014_id', 'c319_014_id');
    }
    function scopeGetIdMeta($query, $pof, $ft = false )
    {
        $cargo = $pof->cargo;
		    $cargo_id = $cargo->c030_id;
        $areaCargo = $cargo->c030_001_id;
        $horasPof = $pof->c034_horas;
        $ft_horas = $ft? $ft->c079_horas:null;
        $junta_id = $pof->establecimiento->c011_014_id;
        $modalidad = $pof->establecimiento->c011_012_id;
        $turno = $pof->c034_035_id1;

        $requiere_horas = $cargo->c030_requiere_horas;

        $query->where("c319_030_id", $cargo_id);

        if ($areaCargo == "I") {
            $query->where("c319_035_id", $turno );
        }

        if ($areaCargo == "P") {
            $query->where("c319_035_id", $turno);
        }

        // Curricular...
        if ($areaCargo == "C") {
            if (!is_null($horasPof) && $horasPof > 0) {
                $query->where("c319_horas", $horasPof);
            } else {
                $query->where("c319_035_id", $turno);
            }

        }

        // Especiales
        if ($areaCargo == "E") {
            // Horas
            if (!is_null($horasPof) && $horasPof > 0) {
                $query->where("c319_horas", $horasPof);
            } else {
                $query->where("c319_035_id", $turno);
            }
            // Cargo y Modalidad ER
            if ($cargo_id == 1040)
            {
                if (in_array($modalidad, array('ER','JC', 'JS')))
                {
                    $query->where("c319_012_id", $modalidad);
                }
            }
        }


        /**
         *  area Cargo es A (Adultos) y 014 = 11 $q->andWhere("cc319_035_id = ?", $pof->getTurnoId());
         */
        if ($areaCargo == "A" && $junta_id == 11) {
            $query->where("c319_035_id", $turno);
        }

        /**
         * Area Cargo CENS (M) y 014 = 7 para los CENS
         */

        if ($areaCargo == "M" && $junta_id == 7) {
            if ($cargo_id != 1599) {
                $query->where("c319_035_id", $turno)
                    ->where("c319_030_id", $cargo_id);
            }
        }

        /**
         * Normales
         */

        if ($modalidad == 'ET' && $junta_id == 1) {
            if ($requiere_horas == 'S') {

                $query->where("c319_014_id", $junta_id);
                $query->where("c319_012_id", $modalidad);

                if ($cargo_id == 5029 || $cargo_id == 1567 || $cargo_id == 1580) /* Estos cargos se buscan con horas en la tabla cftm4 para la junta 1 */ {
                    $query->where("c319_horas", $horasPof);
                }
            } else {
                if ($cargo_id == 1511 && $ft) /* Este cargo se busca con horas en la tabla cftm4 */ {
                    $horas = $ft_horas;
                    if (is_null($horas)) {
                        $horas = 0;
                    }
                    $query->where("c319_horas", $horas);
                }

                $query->where("c319_014_id", $junta_id);
                $query->where("c319_012_id", $modalidad);
            }
        }

        if ($modalidad == 'ET' && ($junta_id == 4 || $junta_id == 5)) {
            if ($requiere_horas == "S") {
                $query->where("c319_014_id", 0);
                $query->where("c319_012_id", $modalidad);
                /* Para estas juntas, el cargo 5029 no se busca con horas en la tabla cftm4 y los cargos 1567 y 1580 no existen */
            } else {

                if ($cargo_id == 1511 && $ft) /* Este cargo es el único que se busca con horas en la tabla cftm4 para junta 4 y 5 */ {
                    $horas = $ft_horas;
                    if (is_null($horas)) {
                        $horas = 0;
                    }
                    $query->where("c319_horas", $horas);
                }
                $query->where("c319_014_id", 0);
                $query->where("c319_012_id", $modalidad);
            }
        }


        /**
         *  EDUCACION MEDIA
         */

        if ($modalidad == 'EM') /* Aquí a diferencia de ET no se busca por junta */ {
            if ($requiere_horas == 'S') {
                $query->where("c319_012_id", $modalidad);
            } else {
                if ($cargo_id == 1511 && $ft) /* Este es el único cargo que se busca con horas en la tabla cftm4 para educación media */ {
                    $horas = $ft_horas;
                    if (is_null($horas)) {
                        $horas = 0;
                    }
                    $query->where("c319_horas", $horas);
                }
                $query->where("c319_012_id", $modalidad);
            }
        }

        /**
         *  ARTISTICA
         */
        if ($modalidad == 'MA') {
            if ($requiere_horas != 'S') {
                $horasPof = 0;
            }
            $query->where("c319_012_id", $modalidad);
        }

        /**
         *  Modalidad Normales Media
         */
        if (in_array($modalidad, array('SI', 'SU', 'UP'))) {
            $query->where("c319_012_id", $modalidad);
        }



        return $query;
    }


}
