<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class Disponible extends Model
{
    protected $table = '071_DISPONIBLES';


    protected $dates = [ 'c071_fcmzo'];
    public function oriAcceso() {
        return $this->hasOne(OriAcceso::class, 'c003_id', 'c071_003_id');
    }

    public function oriVacante() {
        return $this->hasOne(OriVacante::class, 'c005_id', 'c071_005_id');
    }

    public function asignatura() {
        return $this->hasOne(Asignatura::class, 'c010_id', 'c071_010_id');
    }

    public function turno() {
        return $this->hasOne(Turno::class, 'c035_id', 'c071_035_id1');
    }

    public function turno2() {
        return $this->hasOne(Turno::class, 'c035_id', 'c071_035_id1');
    }

    public function tramo() {
        return $this->hasOne(Tramo::class, 'c009_id', 'c071_009_id');
    }

    public function cargo() {
        return $this->hasOne(Cargo::class, 'c030_id', 'c071_030_id');
    }

    public function plan() {
        return $this->hasOne(Plan::class, 'c007_id', 'c071_007_id');
    }

    public function establecimiento() {
        return $this->hasOne(Establecimiento::class, 'c011_id', 'c071_011_id');
    }

    public function normaAlta() {
        return $this->hasOne(Norma::class, 'c013_id', 'c071_013_idalta');
    }

    public function normaBaja() {
        return $this->hasOne(Norma::class, 'c013_id', 'c071_013_idbaja');
    }

    public function nivel() {
        return $this->hasOne(Nivel::class, 'c077_id', 'c071_077_id');
    }

    public function curso() {
        return $this->hasOne(Curso::class, 'c089_id', 'c071_089_id');
    }

    public function persona() {
        return $this->hasOne(Persona::class, 'c020_id', 'c071_020_id_des');
    }
    public function titularAnterior() {
        return $this->hasOne(Persona::class, 'c020_id', 'c071_020_id_rem');
    }
    public function normaCreacion() {
        return $this->hasOne(Norma::class, 'c013_idc', 'c071_013_idcreacion');
    }
    public function normaExpedienteElectronico() {
        return $this->hasOne(Norma::class, 'c013_idc', 'c071_013_idee');
    }

    public function tipoMovimiento() {
        return $this->hasOne(TipoMovimiento::class, 'c068_id', 'c071_068_id');
    }
    public function familiaProfesional() {
        return $this->hasOne(FamiliaProfesional::class, 'c461_id', 'c071_461_id');
    }
    public function pedidoTp() {
        return $this->hasOne(PedidoTp::class, 'c298_id', 'c071_298_id');
    }




}
