<?php

namespace App\Models;


use App\Http\Resources\OriCeseResource;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class Ft extends Model
{
    protected $table = '079_FORMUT';
		protected $primaryKey = 'c079_id';
		public $timestamps = false;
		protected $fillable = ['c079_id_meta4'];

		public function oriAcceso() {
        return $this->hasOne(OriAcceso::class, 'c003_id', 'c079_003_id');
    }

    public function oriVacante() {
        return $this->hasOne(OriVacante::class, 'c005_id', 'c079_005_id');
    }
    public function oriLicencia() {
        return $this->hasOne(OriLicencia::class, 'c004_id', 'c079_004_id');
    }

    public function oriCese() {
        return $this->hasOne(OriCese::class, 'c006_id', 'c079_006_id');
    }
    public function origen() {
        return $this->hasOne(Origen::class, 'c239_id', 'c079_239_id');
    }

    public function persona() {
        return $this->hasOne(Persona::class, 'c020_id', 'c079_020_id');
    }

    public function personaReemplazada() {
        return $this->hasOne(Persona::class, 'c020_id', 'c079_020_id_rem');
    }
    public function normaBaja() {
        return $this->hasOne(Norma::class, 'c013_id', 'c079_013_baja_id');
    }
    public function normaTomaPosecion() {
        return $this->hasOne(Norma::class, 'c013_id', 'c079_013_toma_de_posesion_id');
    }
    public function asignatura() {
        return $this->hasOne(Asignatura::class, 'c010_id', 'c079_010_id');
    }
		public function licenciaFt() {
				return $this->hasMany(LicenciaFt::class, 'c260_079_id', 'c079_id');
		}
}
