<?php

namespace App\Models;


use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class Persona extends Model
{

    protected $table = '020_ARDAT';
    protected $dates = [ 'c020_fnac'];

    public function provincia() {
        return $this->hasOne(Provincia::class, 'c181_id', 'c020_181_id');
    }

    public function localidad() {
        return $this->hasOne(Localidad::class, 'c117_id', 'c020_117_id');
    }

    public function origen() {
        return $this->hasOne(Origen::class, 'c239_id', 'c020_239_id');
    }

    public function nacionalidad() {
        return $this->hasOne(Nacionalidad::class, 'c070_id', 'c020_070_id');
    }

    public function estadoCivil() {
        return $this->hasOne(EstadoCivil::class, 'c072_id', 'c020_072_id');
    }

    public function titProf() {
        return $this->hasOne(TitProf::class, 'c133_id', 'c020_133_id');
    }

    public function estudioNd() {
        return $this->hasOne(TitProf::class, 'c150_id', 'c020_150_id');
    }

    public function tipoDiscapacidad() {
        return $this->hasOne(TitProf::class, 'c283_id', 'c020_283_id');
    }

    public function tipoDoc() {
        return $this->hasOne(TitProf::class, 'c131_id', 'c020_131_id');
    }

    public function tipoGenero() {
        return $this->hasOne(TitProf::class, 'c126_id', 'c020_126_id');
    }


    public function titular() {
        return $this->hasMany(Pof::class, 'c034_020_id_des', 'c020_id');
    }

    public function pofs() {
        return $this->hasMany(Pof::class, 'c034_020_id_des', 'c020_id');
    }


/*    public function pofFt() {
        return $this->hasMany(Pof::class, 'c034_020_documento_des', 'c020_documento')
            ->whereRaw('c034_id in (select c079_034_id from 079_FORMUT where  )');
    }
    public function pofsRem() {
        return $this->hasMany(Pof::class, 'c034_020_documento_rem', 'c020_documento');
    }
    public function ft() {
        return $this->hasMany(Ft::class, 'c020_id', 'c079_020_id');
    }
    public function ftRem() {
        return $this->hasMany(Ft::class, 'c020_id', 'c079_020_id_rem');
    }*/



}
