<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class Pof extends Model
{
    protected $table = '034_POF';
		protected $primaryKey = 'c034_id';
		public $timestamps = false;
		protected $fillable = ['c034_id_meta4'];
    protected $dates = [ 'c034_fcmzo'];
    public function oriAcceso() {
        return $this->hasOne(OriAcceso::class, 'c003_id', 'c034_003_id');
    }

    public function oriVacante() {
        return $this->hasOne(OriVacante::class, 'c005_id', 'c034_005_id');
    }


    public function asignatura() {
        return $this->hasOne(Asignatura::class, 'c010_id', 'c034_010_id');
    }
		public function plan() {
				return $this->hasOne(Plan::class, 'c007_id', 'c034_007_id');
		}
    public function turno() {
        return $this->hasOne(Turno::class, 'c035_id', 'c034_035_id1');
    }

    public function turno2() {
        return $this->hasOne(Turno::class, 'c035_id', 'c034_035_id1');
    }

    public function tramo() {
        return $this->hasOne(Tramo::class, 'c009_id', 'c034_009_id');
    }

    public function cargo() {
        return $this->hasOne(Cargo::class, 'c030_id', 'c034_030_id');
    }



    public function establecimiento() {
        return $this->hasOne(Establecimiento::class, 'c011_id', 'c034_011_id');
    }

    public function normaAlta() {
        return $this->hasOne(Norma::class, 'c013_id', 'c034_013_idalta');
    }

    public function normaBaja() {
        return $this->hasOne(Norma::class, 'c013_id', 'c034_013_idbaja');
    }

    public function nivel() {
        return $this->hasOne(Nivel::class, 'c077_id', 'c034_077_id');
    }

    public function curso() {
        return $this->hasOne(Curso::class, 'c089_id', 'c034_089_id');
    }
/*    public function licenciaTitular() {

        return $this->hasMany(LicenciaTitular::class, ['c256_034_id','c034_020_id_des'], ['c034_id','c034_020_id_des']);
    }*/

		public function bajaTitular() {

				return $this->hasOne(LicenciaTitular::class, ['c240_034_id','c240_020_id'], ['c034_id','c034_020_id_des']);
		}


		public function persona() {
        return $this->hasOne(Persona::class, 'c020_id', 'c034_020_id_des');
    }
    public function titularAnterior() {
        return $this->hasOne(Persona::class, 'c020_id', 'c034_020_id_rem');
    }
    public function normaCreacion() {
        return $this->hasOne(Norma::class, 'c013_idc', 'c034_013_idcreacion');
    }
    public function normaExpedienteElectronico() {
        return $this->hasOne(Norma::class, 'c013_idc', 'c034_013_idee');
    }

    public function tipoMovimiento() {
        return $this->hasOne(TipoMovimiento::class, 'c068_id', 'c034_068_id');
    }
    public function familiaProfesional() {
        return $this->hasOne(FamiliaProfesional::class, 'c461_id', 'c034_461_id');
    }
    public function pedidoTp() {
        return $this->hasOne(PedidoTp::class, 'c298_id', 'c034_298_id');
    }
    public function caracter() {
        return $this->hasOne(Caracter::class, 'c156_id', 'c034_caracter');
    }
		public function aperturas() {
				return $this->hasMany(PofTp::class, 'c088_034_id', 'c034_id');
		}

		public function aprobacionCreacionArea() {

				return $this->hasOne(PofCreacionAprobacionArea::class, 'c737_034_id', 'c034_id');
		}

		public function ftSinBaja() {
				return $this->hasMany(Ft::class, 'c079_034_id', 'c034_id')->whereNull('c079_fecha_baja');
		}

    public  function scopePuestoTitular($query)
    {
       $query->whereRaw("c034_caracter in ('T', '1','2') ");
        return $query;
    }
    public  function scopeInterinosatitularizarCondition($query, $idPersona)
    {

        $query = "c034_id in (select c066_034_id from 066_SERVICIOS where c066_caracter='I' and 020_id_des='".$idPersona."'
         and c066_fcese is null and c066_fcmzo < '2020-04-01' )";

        $query->whereRaw($query);
        return $query;
    }

    public  function scopeSuplenteaTitularizarCondition($query,$idPersona)
    {

             $query->whereRaw("c034_id in
       (select c066_034_id from 066_SERVICIOS where c066_caracter = 'S'
       and c066_fcmzo < '2020-04-01' and c066_fcese is null
        and c066_020_id_des =".$idPersona.") ");

        $query->whereRaw($query);
        return $query;
    }

		public static  function getPuestosoAltaTpTc($id)
		{

				$campos_arr = array(
						'c034_id', 'p.c034_ano', 'c034_div', 'c034_cuat', 'c034_comision' ,'c034_gef','c034_curso','c034_horas', //pof
						'c011_id','c011_nom','c011_de','c011_dir','c011_esc', //rdtablecimiento
						'c030_id','c030_des', //cargo
						'c035_id','c035_des', //turno
						'c010_id','c010_des', //asignatura
						'c007_id','pl.c007_des', //plan
						'c009_id','c009_des', //tramo
						'c002_id','c002_des', //area
						'c156_id','c156_des', //caracter
						'( select count(*) from 088_POFTP  where c088_034_id = p.c034_id ) as tiene_apertura ',
						'( select  count(*) from 088_POFTP where c088_034_creacion_vacante_id = p.c034_id ) as cant_aperturas',
						"( select count(*) as cantidad from 066_SERVICIOS  where c066_034_id=p.c034_id  and c066_fcese is not null  	AND (( p.c034_020_id_rem = c066_020_id_des	and c066_caracter='T') or c066_caracter='I' )	) 
						+
						( select count(*) as cantidad from 240_BAJA_TITULARES_WSAD  where c240_034_id=p.c034_id  and c240_fecha_baja is not null  	) 
						+
						( select count(*) as cantidad from 079_FORMUT  where 	c079_034_id=p.c034_id 	and c079_fecha_baja is not null  	and c079_caracter = 'I'	) as tiene_baja",
						'SUM(CASE WHEN (fts.c079_id IS NOT NULL AND fts.c079_fecha_toma_de_posecion IS NULL AND fts.c079_fecha_baja is null    ) THEN 1 ELSE 0 END) as cnt_fts_sin_fecha_posesion'
				);

				$conditions = array(
						" ((  p.c034_caracter = 'V' or  p.c034_caracter = 'I')
                OR (p.c034_caracter = 'T' AND 
                    (   bajastit.c240_id IS NOT NULL OR 
             
                       (select count(*) as cantidad from 066_SERVICIOS  where c066_034_id=p.c034_id and c066_fcese is not null  	AND p.c034_020_id_rem = c066_020_id_des	and c066_caracter='T' ) >0
                    ) ) 
                OR ( 
		           (  p.c034_caracter = 'V' or  p.c034_caracter = 'I')	AND ( 	select count(*) as cantidad from 079_FORMUT  where
							c079_034_id = p.c034_id and c079_fecha_baja is not null	and  c079_caracter = 'I'   	) > 0 ))",
						'c.c030_id IN (1507,1528,1549, 1550,1504,1599)',
						'p.c034_id NOT IN (SELECT ft2.c079_034_id FROM 079_FORMUT ft2 where   ft2.c079_fecha_baja IS  NULL  and ft2.c079_034_id = p.c034_id )',
						'p.c034_011_id = '.$id ,
				);

				$query = " SELECT  " . implode( " , ", $campos_arr) . " 
										FROM 034_POF AS p 
										INNER JOIN 011_NOMENCLADOR n ON p.c034_011_id = n.c011_id
										INNER JOIN 030_CARGOS c ON p.c034_030_id = c.c030_id 
										INNER JOIN 035_TURNOS t ON p.c034_035_id1 = t.c035_id
										LEFT JOIN 010_ASIGNATURAS a ON p.c034_010_id = a.c010_id 
										LEFT JOIN 240_BAJA_TITULARES_WSAD bajastit ON p.c034_id = bajastit.c240_034_id 
										LEFT JOIN 007_PLANES pl ON p.c034_007_id = pl.c007_id 
										LEFT JOIN 009_TRAMOS tr ON p.c034_009_id = tr.c009_id
										LEFT JOIN 002_AREANOMEN ae on n.c011_002_id = ae.c002_id 
										LEFT JOIN 156_CARACTER caracter ON p.c034_caracter = caracter.c156_id 
										LEFT JOIN 079_FORMUT fts ON p.c034_id = fts.c079_034_id 
										WHERE " . implode( " AND ", $conditions) . " 
										GROUP BY p.c034_id
										HAVING cnt_fts_sin_fecha_posesion = 0";

				$data =  \DB::select($query);
				return $data;
		}


}
