<?php

namespace App\Models;


use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class Servicio extends Model
{
    protected $table = '066_SERVICIOS';
    protected $dates = ['c066_fcmzo'];

    public function oriAcceso() {
        return $this->hasOne(OriAcceso::class, 'c003_id', 'c066_003_id');
    }

    public function oriVacante() {
        return $this->hasOne(OriVacante::class, 'c005_id', 'c066_005_id');
    }
    public function oriLicencia() {
        return $this->hasOne(OriLicencia::class, 'c004_id', 'c066_004_id');
    }

    public function oriCese() {
        return $this->hasOne(OriCese::class, 'c006_id', 'c066_006_id');
    }
    public function normaBaja() {
        return $this->hasOne(Norma::class, 'c013_id', 'c079_013_baja_id');
    }
    public function normaAlta() {
        return $this->hasOne(Norma::class, 'c013_id', 'c066_013_idalta');
    }
    public function normaBajaUin() {
        return $this->hasOne(Norma::class, 'c013_id', 'c066_013_idbajauin');
    }
    public function normaProv() {
        return $this->hasOne(Norma::class, 'c013_id', 'c066_013_idprov');
    }
    public function normaBajaExpedienteElectronico() {
        return $this->hasOne(Norma::class, 'c013_id', 'c066_013_ideeb');
    }
    public function normaAltaExpedienteElectronico() {
        return $this->hasOne(Norma::class, 'c013_id', 'c066_013_ideea');
    }

    public function asignatura() {
        return $this->hasOne(Asignatura::class, 'c010_id', 'c066_010_id');
    }

    public function turno() {
        return $this->hasOne(Turno::class, 'c035_id', 'c066_035_id1');
    }

    public function turno2() {
        return $this->hasOne(Turno::class, 'c035_id', 'c066_035_id2');
    }
    public function caracter() {
        return $this->hasOne(Caracter::class, 'c156_id', 'c034_caracter');
    }
    public function establecimiento() {
        return $this->hasOne(Establecimiento::class, 'c011_id', 'c066_011_id');
    }
    public function plan() {
        return $this->hasOne(Plan::class, 'c007_id', 'c066_007_id');
    }
    public function cargo() {
        return $this->hasOne(Cargo::class, 'c030_id', 'c066_030_id');
    }
    public function tramo() {
        return $this->hasOne(Tramo::class, 'c009_id', 'c066_009_id');
    }


}
