<?php

namespace App\Models;


use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Database\Eloquent\Builder;
use App\Helpers\FormatHelper;

class TitularizacionFormulario extends Model
{
    protected $table = '833_TITULARIZACION_FORMULARIO';
    public $timestamps = false;
    protected $dates = ['c833_creado','c833_modificado'];
    protected $fillable = ['c833_id','c833_creado','c833_modificado','c833_020_id','c833_832_id','c833_011_id','c833_json_cargos','c833_830_id','c833_expediente','c833_013_id'];
    protected $with = ['estado'];
    protected $primaryKey = 'c833_id';

    public function persona() {
        return $this->hasOne(Persona::class, 'c020_id', 'c833_020_id');
    }
    public function estado() {
        return $this->hasOne(TitularizacionEstado::class, 'c832_id', 'c833_832_id');
    }

    public function establecimiento() {
        return $this->hasOne(Establecimiento::class, 'c011_id', 'c833_011_id');
    }

    public function norma() {
        return $this->hasOne(Persona::class, 'c013_id', 'c833_013_id');
    }

}
