<?php

namespace App\Service\Search;


use App\Http\Requests\PofsSearchRequest;
use App\Http\Requests\TurnosSearchRequest;
use App\Models\Pof;
use App\Models\Turno;
use App\Service\Search\Maps\PofsSearchMap;
use App\Service\Search\Maps\TurnosSearchMap;


class PofsSearchService extends AbstractSearchService
{
    protected $request;


    public function __construct(PofsSearchRequest $request)
    {
        $this->request = $request;
        $this->map_columns = [];
        $this->exclude_columns = array(...$this->exclude_columns );
        $this->order_by_columns = [];
        $this->map_columns = PofsSearchMap::$map;
    }

    public function search( $paginate = false )
    {

        $this->request->validated();
				$query = Pof::query()->with(['plan', 'cargo','asignatura','establecimiento','turno','persona','caracter',
						'titularAnterior','OriVacante','asignatura.asignaturaEspecialidad','curso',
						'aprobacionCreacionArea', 'ftSinBaja','ftSinBaja.persona','ftSinBaja.oriCese','ftSinBaja.oriLicencia',
						'ftSinBaja.oriVacante','ftSinBaja.personaReemplazada',  'ftSinBaja.licenciaFt', 'ftSinBaja.licenciaFt.oriLicencia'
				]	);
				//'licenciaTitular','licenciaTitular.oriLicencia',
					//todo agregar lo que sigue
						//->whereRaw(' ( c034_caracter in ("T", "I","S","1", "2" ,"V") or (c034_caracter =  "Z" AND c079_fecha_baja is NULL AND c079_id is NOT NULL ) ) ' ) ;


						return   $this->find($query)->get() ;
    }


}
