<?php

namespace App\Transformers;


use Illuminate\Pagination\Paginator;

class ApiPaginateCollection
{
    public $data;
    public $meta;
    public $links;

    public function __construct(Paginator $data)
    {
        //items
        $this->data = $data->items();

        //info
        $this->meta = new \stdClass();
        $this->meta->per_page = $data->perPage();
        $this->meta->current_page = (string) $data->currentPage();
        $this->meta->from = (string) $data->firstItem();
        $this->meta->to = (string) $data->lastItem();

        //links
        $this->links = new \stdClass();
        $this->links->first = $data->url(1);
        $this->links->prev = $data->previousPageUrl();
        $this->links->next = $data->nextPageUrl();
    }
}
