<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware(['auth:sanctum'])->get('/user', function (Request $request) {
    return $request->user();
});
Route::prefix('v1')->group(function() {
		Route::name('area.')->prefix('areas')->namespace('Area')->group(base_path('routes/api/area_route.php'));
		Route::name('caracter.')->prefix('caracteres')->namespace('Caracter')->group(base_path('routes/api/caracter_route.php'));
		Route::name('cargo.')->prefix('cargos')->namespace('Cargo')->group(base_path('routes/api/cargo_route.php'));
		Route::name('asignatura.')->prefix('asignaturas')->namespace('Asignatura')->group(base_path('routes/api/asignatura_route.php'));
		Route::name('turno.')->prefix('turnos')->namespace('Turno')->group(base_path('routes/api/turno_route.php'));
		Route::name('modalidad.')->prefix('modalidades')->namespace('Modalidad')->group(base_path('routes/api/modalidades_route.php'));
		Route::name('nivel.')->prefix('niveles')->namespace('Nivel')->group(base_path('routes/api/niveles_route.php'));
});


